(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('reflect-metadata'), require('qmuzik-angular-model-core'), require('@angular/common/http'), require('rxjs/operators'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('qmuzik-angular-service', ['exports', '@angular/core', 'rxjs', 'reflect-metadata', 'qmuzik-angular-model-core', '@angular/common/http', 'rxjs/operators', '@angular/router'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['qmuzik-angular-service'] = {}, global.ng.core, global.rxjs, null, global.qmuzikAngularModelCore, global.ng.common.http, global.rxjs.operators, global.ng.router));
}(this, (function (exports, core, rxjs, reflectMetadata, qmuzikAngularModelCore, http, operators, router) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * All generated data services for standard components inherits from this base service
     * Contains generic/shared functionality as well as overideable interface methods
     */
    var BaseService = /** @class */ (function () {
        function BaseService() {
            this.loggedUser = "";
            this.defaults = [];
            this.defaultsSubscription = new rxjs.Subject();
            this.autoSelectSubscription = new rxjs.Subject(); //note: indicate to the view that auto-selection check is complete
            this.initialisationService = null;
            this.totalResultCount = new qmuzikAngularModelCore.TotalResultCount();
        }
        /**
         * Standard error handler
         *
         * @param error
         */
        BaseService.prototype.handleError = function (error) {
            var message = "";
            var companyID = error.headers.get("CompanyID");
            var invalidReasonCode = error.headers.get("InvalidReasonCode");
            if (error.error instanceof ErrorEvent) {
                //client-side or network error occurred. Handle it accordingly.
                console.error('An error occurred:', error.error.message);
                message = error.error.message;
            }
            else {
                // The backend returned an unsuccessful response code.
                // The response body may contain clues as to what went wrong,
                console.error("Backend returned code " + error.status + ", " +
                    ("body was: " + JSON.stringify(error.error)));
                //try different options for the description
                if (error.error.error_description != null) {
                    message = error.error.error_description;
                }
                else if (error.error.ModelState != null) {
                    for (var key in error.error.ModelState) {
                        if (error.error.ModelState[key])
                            message += error.error.ModelState[key] + '\n';
                    }
                    ;
                }
                else if (error.error.Message != null) {
                    message = error.error.Message + '\r\n' + '\r\n' + error.error.ExceptionMessage;
                }
                else {
                    if ((error.error !== undefined) && (error.error != null)) {
                        message = error.error;
                    }
                    else {
                        message = 'An error has occurred. Please retry.';
                    }
                }
                ;
            }
            // return an ErrorObservable with a user-facing error message
            return rxjs.throwError(message);
        };
        ;
        /**
         * Joins result sets from calls to multiple datacontexts into one dataset
         *
         * @param data
         */
        BaseService.prototype.FormatObserveablesArray = function (data) {
            var myResults = [];
            for (var i = 0; i < data.length; i++) {
                if ((data[i] !== undefined)
                    &&
                        (data[i] !== null))
                    for (var j = 0; j < data[i].length; j++) {
                        myResults.push(data[i][j]);
                    }
            }
            return myResults;
        };
        /**
         * Perform any formatting required before web API is called upon
         * to save a modelstate
         *
         * @param modelState
         * @param isNew
         */
        BaseService.prototype.FormatBeforeSave = function (modelState, isNew) {
            var keys = Object.keys(modelState);
            for (var j = 0; j < keys.length; j++) {
                if (modelState[keys[j]] !== null) {
                    //note: date formatting
                    var isDate = Reflect.getMetadata("IsDate", modelState, keys[j]);
                    var isEditable = Reflect.getMetadata("Editable", modelState, keys[j]);
                    if (isDate && isEditable) {
                        var datePicker = modelState[keys[j]];
                        var date = new Date(datePicker.year, datePicker.month - 1, datePicker.day);
                        modelState[keys[j]] = date;
                    }
                }
                //command values
                if (isNew) {
                    var newValueCommand = Reflect.getMetadata("NewValueCommand", modelState, keys[j]);
                    if (newValueCommand === "Now") {
                        modelState[keys[j]] = new Date();
                    }
                }
                else {
                    var updateValueCommand = Reflect.getMetadata("UpdateValueCommand", modelState, keys[j]);
                    if (updateValueCommand === "Now") {
                        modelState[keys[j]] = new Date();
                    }
                    if ((updateValueCommand === "LoggedInUserId") && (this.loggedUser !== "")) {
                        modelState[keys[j]] = this.loggedUser;
                    }
                }
            }
            return modelState;
        };
        /**
         *  On a new click we may want to initialise
         *      certain properties to a "variable" value
         *      such as:
         *  TodaysDate
         *  NextWorkDate
         *  TomorrowsDate
         *  LoggedInUser
         *  SystemSettings:<PropertyName>
         *  LoggedInUserDivision:<PropertyName>
         *  LoggedInUserCostCenter:<PropertyName>
         *  EndPoint:<PropertyName> e.g."EndPoint:api/ViewCustomerOrdersHeaderCRUDLibrary/GetMySetting", expects a GET, expects single Parameter "PropertyName"
         *
         * @param modelState
         */
        BaseService.prototype.FormatOnNew = function (modelState) {
            //note: we want to check if any decorators have been overridden
            //      just a side note for later.
            //note: defaults set up will take precendence over this
            //      it will only apply the setting if it's value is null or undefined 
            try {
                var keys = Object.keys(modelState);
                for (var j = 0; j < keys.length; j++) {
                    //command values
                    var newValueCommand = Reflect.getMetadata("NewValueCommand", modelState, keys[j]);
                    if ((newValueCommand === undefined)
                        ||
                            (newValueCommand === null)) {
                        continue;
                    }
                    if ((modelState[keys[j]] !== undefined)
                        &&
                            (modelState[keys[j]] !== null)) {
                        continue;
                    }
                    var commandArray = newValueCommand.split(':');
                    if (newValueCommand === "TodaysDate") {
                        modelState[keys[j]] = new Date();
                        continue;
                    }
                    if (newValueCommand === "TomorrowsDate") {
                        var date = new Date();
                        date.setDate(date.getDate() + 1);
                        modelState[keys[j]] = date;
                        continue;
                    }
                    if (newValueCommand === "NextWorkDate") {
                        for (var i = 0; i < this.initialisationService.companyWorkdays[modelState.CompanyID].length; i++) {
                            if (this.DaysBetween((new Date(this.initialisationService.companyWorkdays[modelState.CompanyID][i].WorkDate)), new Date()) >= 0) {
                                modelState[keys[j]] = new Date(this.initialisationService.companyWorkdays[modelState.CompanyID][i].WorkDate);
                                break;
                            }
                        }
                        continue;
                    }
                    if (newValueCommand === "LoggedInUser") {
                        //note: here we must retrieve the logged in user based upon company
                        for (var i = 0; i < this.initialisationService.loginService.dataContext.length; i++) {
                            if (modelState["CompanyID"] === this.initialisationService.loginService.dataContext[i].CompanyID) {
                                modelState[keys[j]] = this.initialisationService.loginService.dataContext[i].EmployeeId;
                                break;
                            }
                        }
                        continue;
                    }
                    if (commandArray.length === 2) {
                        if (commandArray[0] === "SystemConfiguration") {
                            if (this.initialisationService.companySystemConfiguration[modelState["CompanyID"]]) {
                                modelState[keys[j]] = this.initialisationService.companySystemConfiguration[modelState["CompanyID"]][commandArray[1]];
                            }
                            continue;
                        }
                        if (commandArray[0] === "LoggedInUserDivision") {
                            //note: use initialisation service to retrieve the division information for logged in user
                            continue;
                        }
                        if (commandArray[0] === "LoggedInUserCostCenter") {
                            //note: use initilisation service to retrieve the cost center information for logged in user 
                            continue;
                        }
                    }
                }
            }
            catch (e) {
                this.handleError(e);
            }
            return modelState;
        };
        /**
         * Check if any property is a date and editable and convert
         *
         * @param modelState
         */
        BaseService.prototype.FormatBeforeSend = function (modelState) {
            var keys = Object.keys(modelState);
            for (var j = 0; j < keys.length; j++) {
                if (modelState[keys[j]] !== null) {
                    //note: date formatting
                    var isDate = Reflect.getMetadata("IsDate", modelState, keys[j]);
                    var isEditable = Reflect.getMetadata("Editable", modelState, keys[j]);
                    if (isDate && isEditable) {
                        var datePicker = modelState[keys[j]];
                        var date = new Date(datePicker.year, datePicker.month - 1, datePicker.day);
                        modelState[keys[j]] = date;
                    }
                }
            }
            return modelState;
        };
        /**
         * Retrieve the operators of an advanced filter
         *
         * @param filter
         * @param advancedFilter
         */
        BaseService.prototype.GetOperatorArray = function (filter, advancedFilter) {
            var orOperators = [];
            //run through filters,a always add like operator
            //run through each "or" filter
            if (filter !== null) {
                for (var i = 0; i < filter.length; i++) {
                    //run trough the properties
                    //check if an operator have been set
                    //check if a value have been set
                    //if so, add the operator
                    //else, add null
                    //start empty
                    var andOperators = [];
                    var keys = Object.keys(filter[i]);
                    for (var j = 0; j < keys.length; j++) {
                        if (filter[i][keys[j]] === null) {
                            continue;
                        }
                        else {
                            andOperators.push({
                                PropertyName: keys[j],
                                OperatorValue: "*"
                            });
                        }
                    }
                    orOperators.push(andOperators);
                }
            }
            if ((advancedFilter === undefined) || (advancedFilter === null)) {
                return orOperators;
            }
            //run through each "or" filter
            for (var i = 0; i < advancedFilter.length; i++) {
                //run trough the properties
                //check if an operator have been set
                //check if a value have been set
                //if so, add the operator
                //else, add null
                //start empty
                var andOperators = [];
                var keys = Object.keys(advancedFilter[i]);
                for (var j = 0; j < keys.length; j++) {
                    if (advancedFilter[i][keys[j]] === null) {
                        continue;
                    }
                    var operator = Reflect.getMetadata("Operator", advancedFilter[i], keys[j]);
                    if (operator !== undefined) {
                        andOperators.push({
                            PropertyName: keys[j],
                            OperatorValue: operator
                        });
                    }
                }
                orOperators.push(andOperators);
            }
            return orOperators;
        };
        /**
         * Retrieve the number of rows that will be requested from the service layer
         *
         * @param key
         * @param modelState
         */
        BaseService.prototype.GetNumberOfRows = function (key, modelState) {
            var numberOfRows = Reflect.getMetadata("NumberOfRows", modelState, key);
            if ((numberOfRows === undefined) || (numberOfRows === null)) {
                return null;
            }
            else {
                return numberOfRows;
            }
        };
        /**
         * Calculate the difference in days between 2 dates
         *
         * @param date1
         * @param date2
         */
        BaseService.prototype.DaysBetween = function (date1, date2) {
            //Get 1 day in milliseconds
            var one_day = 1000 * 60 * 60 * 24;
            // Convert both dates to milliseconds
            var date1_ms = date1.getTime();
            var date2_ms = date2.getTime();
            // Calculate the difference in milliseconds
            var difference_ms = date2_ms - date1_ms;
            // Convert back to days and return
            return Math.round(difference_ms / one_day);
        };
        //note: a default implementation so that we don't have to
        //      re-generate all our code when adding method to data service interface
        //#region override child
        BaseService.prototype.DoInstanceActions = function (modelState, isNew, instance, isList) {
            return new rxjs.Observable(null);
        };
        BaseService.prototype.GetDefaultsInstance = function (instanceId, symbolInstanceId, CompanyIDPassed) {
            return new rxjs.Observable(null);
        };
        BaseService.prototype.GetSymbolInstanceSavedObjectCount = function (instanceInformation, companyIDPassed) {
            return new rxjs.Observable(null);
        };
        BaseService.prototype.AddToInstance = function (modelState) {
            return new rxjs.Observable(null);
        };
        BaseService.prototype.DeleteInstanceObjects = function (instance, companyID) {
            return new rxjs.Observable(null);
        };
        BaseService.prototype.GetPrimaryKeyObject = function (values, companyID, serializationLevel) {
            return new rxjs.Observable(null);
        };
        /**
         * Check if an object is of a certain type
         * @param item
         */
        BaseService.prototype.IsType = function (item) {
            return false;
        };
        BaseService.prototype.GetAutoSelect = function (instance, modelState, serializationLevel) {
        };
        return BaseService;
    }());
    BaseService.decorators = [
        { type: core.Injectable }
    ];
    BaseService.ctorParameters = function () { return []; };

    /**
     * General communication between components to manage the application
     */
    var AppManagementService = /** @class */ (function (_super) {
        __extends(AppManagementService, _super);
        function AppManagementService(http, globals) {
            var _this = _super.call(this) || this;
            _this.http = http;
            _this.globals = globals;
            _this.leftRegionExpanded = false;
            _this.sliderValue = 5; //note: always opens initially with value 5
            _this.openDynamicViewRequest = new rxjs.Subject();
            //note: global error handling e.g. displayed outside context of view
            _this.globalErrors = [];
            _this.globalWarnings = [];
            _this.globalInformations = [];
            _this.openMenuSubscription = new rxjs.Subject();
            _this.sliderValueChangedSubject = new rxjs.Subject();
            _this.menuOpen = false;
            return _this;
        }
        /**
         * Retrieve system settings
         */
        AppManagementService.prototype.getSystemSettings = function () {
            return this.http.get(this.globals.apiURL + "api/SystemSettings/")
                .pipe(operators.catchError(this.handleError));
        };
        /**
         * Add a new global error (only if it hasn't been logged)
         * @param notificationMessage
         */
        AppManagementService.prototype.AddGlobalError = function (notificationMessage) {
            for (var i = 0; i < this.globalErrors.length; i++) {
                if (this.globalErrors[i].ErrorMessage === notificationMessage.ErrorMessage) {
                    return;
                }
            }
            this.globalErrors.push(notificationMessage);
        };
        /**
         * Add a new global information message (only if it has not been logged)
         * @param notificationMessage
         */
        AppManagementService.prototype.AddGlobalInformation = function (notificationMessage) {
            for (var i = 0; i < this.globalInformations.length; i++) {
                if (this.globalInformations[i].ErrorMessage === notificationMessage.ErrorMessage) {
                    return;
                }
            }
            this.globalInformations.push(notificationMessage);
        };
        /**
         * Send a notification the the menu has been openend
         */
        AppManagementService.prototype.openMenu = function () {
            this.openMenuSubscription.next();
        };
        return AppManagementService;
    }(BaseService));
    AppManagementService.decorators = [
        { type: core.Injectable }
    ];
    AppManagementService.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: qmuzikAngularModelCore.AppGlobal }
    ]; };

    var LoginService = /** @class */ (function (_super) {
        __extends(LoginService, _super);
        function LoginService(http, appGlobal, router, appManagementService) {
            var _this = 
            //constructor of inherited class must have this call 
            _super.call(this) || this;
            _this.http = http;
            _this.appGlobal = appGlobal;
            _this.router = router;
            _this.appManagementService = appManagementService;
            _this.isLoggedIn = false;
            _this.notifyLoginChange = new rxjs.Subject();
            //note: contains all that is connected e.g. can be used for THIS product
            _this.dataContext = [];
            //note: contains all that is not connected, but active for THIS product
            _this.dataContextNotConnected = [];
            //note: contains all data contexts for NOT FOR THIS product
            _this.dataContextDifferentProduct = [];
            _this.defaultCompanyID = "";
            _this.dataContextSubscription = new rxjs.Subject();
            _this.dataContextIsActiveCount = new rxjs.Subject();
            _this.dataContextIsSelectedCount = new rxjs.Subject();
            //the login route target once you've logged in.
            _this.loginRouteTarget = "blank";
            return _this;
        }
        /**
         * Return the data contexts where the logged in user has access
         * User will have access if it exists in company views
         *
         * @param internalName
         */
        LoginService.prototype.GetValidDataContexts = function (internalName) {
            var validDataContext = [];
            for (var i = 0; i < this.dataContext.length; i++) {
                if (this.initialisationService.companyViews[this.dataContext[i].CompanyID]
                    &&
                        (this.dataContext[i].CompanyID !== "")) {
                    var views = this.initialisationService.companyViews[this.dataContext[i].CompanyID];
                    for (var j = 0; j < Object.keys(views).length; j++) {
                        var view = views[Object.keys(views)[j]];
                        if (view.InternalName === internalName) {
                            //note: found, it is valid for the search
                            //      move to the next data context
                            validDataContext.push(this.dataContext[i]);
                            break;
                        }
                    }
                }
            }
            return validDataContext;
        };
        LoginService.prototype.validateRegistrationInviteToken = function (Token, Email) {
            var apiUrl = this.appGlobal.apiURL + 'api/ProductSettings/ValidateInviteToken';
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('inviteToken', Token);
            httpParams = httpParams.append('emailAddress', Email);
            return this.http.get(apiUrl, {
                params: httpParams
            })
                .pipe(operators.catchError(this.handleError));
        };
        //note: call the oauth registration endpoint to register new users
        //      users register themselves in the authenticate database
        //      this will allow them to query the data contexts that have been
        //      set up for them
        LoginService.prototype.inviteUsers = function (inviteProductData) {
            if (this.selectedDataContext.CompanyID === "") {
                return;
            }
            inviteProductData.InvitedBy = this.selectedDataContext.RealEmployeeId;
            var apiUrl = this.appGlobal.apiURL + 'api/ProductSettings/InviteUser';
            return this.http.post(apiUrl, inviteProductData)
                .pipe(operators.catchError(this.handleError));
        };
        LoginService.prototype.SubscribeToNewDataContext = function (emailAddress, inviteToken) {
            var apiUrl = this.appGlobal.apiURL + 'api/ProductSettings/SubscribeToNewDataContext';
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('inviteToken', inviteToken);
            httpParams = httpParams.append('emailAddress', emailAddress);
            return this.http.get(apiUrl, {
                params: httpParams
            })
                .pipe(operators.catchError(this.handleError));
        };
        //note: call the oauth registration endpoint to register new users
        //      users register themselves in the authenticate database
        //      this will allow them to query the data contexts that have been
        //      set up for them
        LoginService.prototype.registerUser = function (username, email, password, retypePassword, inviteToken) {
            var registrationData = new RegistrationData();
            registrationData.Email = email;
            registrationData.Username = username;
            registrationData.Password = password;
            registrationData.ConfirmPassword = retypePassword;
            registrationData.InviteToken = inviteToken;
            var apiUrl = this.appGlobal.apiURL + 'api/Account/Register';
            return this.http.post(apiUrl, registrationData)
                .pipe(operators.catchError(this.handleError));
        };
        LoginService.prototype.loginExternalProvider = function (username, provider, authToken) {
            var headers = new http.HttpHeaders();
            headers = headers.set('Content-Type', 'application/x-www-form-urlencoded');
            var url = this.appGlobal.apiURL + 'Token';
            return this.http.post(url, ("grant_type=externalToken&username=" + username + "&externalToken=" + authToken + "&provider=" + provider), {
                headers: headers
            })
                .pipe(
            //don't need to tap here, don't want to do anything with it
            operators.catchError(this.handleError));
        };
        LoginService.prototype.verifyUser = function (userId, code) {
            var apiUrl = this.appGlobal.apiURL + 'api/Account/Verify';
            return this.http.post(apiUrl, { UserId: userId, VerificationCode: code })
                .pipe(operators.catchError(this.handleError));
        };
        LoginService.prototype.resetPassword = function (userId, code, newPassword, retypePassword) {
            var apiUrl = this.appGlobal.apiURL + 'api/Account/ResetPassword';
            return this.http.post(apiUrl, { UserId: userId, ResetToken: code, NewPassword: newPassword, ConfirmPassword: retypePassword })
                .pipe(operators.catchError(this.handleError));
        };
        LoginService.prototype.forgotPassword = function (username) {
            var apiUrl = this.appGlobal.apiURL + 'api/Account/ForgotPassword';
            return this.http.post(apiUrl, { Username: username })
                .pipe(operators.catchError(this.handleError));
        };
        //note: token retrieved from authentication service
        //allows the user to select datacontexts available
        LoginService.prototype.getAuthenticateBearerToken = function (username, password) {
            var headers = new http.HttpHeaders();
            headers = headers.set('Content-Type', 'application/x-www-form-urlencoded');
            var url = this.appGlobal.apiURL + 'Token';
            return this.http.post(url, ("grant_type=password&username=" + username + "&password=" + password), {
                headers: headers
            })
                .pipe(
            //don't need to tap here, don't want to do anything with it
            operators.catchError(this.handleError));
        };
        //note: i just want to succeed in receiving the bearer token from the web api Token endpoint
        //      this bearer token will then be persisted for use during this login session
        LoginService.prototype.getBearerToken = function (dataContext) {
            //this will come from the authorisation database
            this.defaultCompanyID = "";
            var url = dataContext.ServiceUri + 'api/Accounts';
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('ClientName', dataContext.CompanyName);
            httpParams = httpParams.append('Password', dataContext.ServicePassword);
            httpParams = httpParams.append('UserId', dataContext.EmployeeId);
            return this.http.get(url, {
                params: httpParams
            })
                .pipe(operators.catchError(this.handleError));
        };
        //note: on expiry of token this method will retrieve a new token
        //      with the refresh token
        LoginService.prototype.getTokenWithRefreshToken = function (dataContext) {
            var url = dataContext.ServiceUri + 'api/Account/AuthoriseWithRefreshToken';
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('ExpiredToken', dataContext.Token);
            httpParams = httpParams.append('RefreshToken', dataContext.RefreshToken);
            return this.http.get(url, {
                params: httpParams
            })
                .pipe(operators.catchError(this.handleError));
        };
        //logout
        LoginService.prototype.logout = function () {
            //note: clear the local storage
            localStorage.removeItem('authData');
            //note: if user log's out auto-login is cleared
            localStorage.removeItem('authDataAuthentication');
            this.appManagementService.leftRegionExpanded = false;
            this.initialisationService.cachedViewRules = {};
            this.initialisationService.cachedViewNotifications = {};
            this.initialisationService.cachedViewProperties = {};
            this.initialisationService.cachedViewPropertiesSymbol = {};
            //set logout flag
            this.isLoggedIn = false;
            this.dataContext = [];
            this.notifyLoginChange.next(this.isLoggedIn);
            this.router.navigate(['/login']);
        };
        //note: when the company id is returned from the backend set the selected context
        LoginService.prototype.setDataContextWithCompanyId = function (companyId) {
            this.defaultCompanyID = companyId;
            for (var i = 0; i < this.dataContext.length; i++) {
                if (companyId === this.dataContext[i].CompanyID) {
                    this.selectedDataContext = this.dataContext[i];
                    this.dataContextSubscription.next(this.selectedDataContext);
                    break;
                }
            }
        };
        // update the DataContext
        LoginService.prototype.updateDataContext = function (dataContext) {
            var apiUrl = this.appGlobal.apiURL + 'api/DataContextViews/';
            var httpParamss = new http.HttpParams();
            httpParamss = httpParamss.append('id', dataContext.CompanyID);
            return this.http.put(apiUrl, dataContext, {
                params: httpParamss
            })
                .pipe(operators.catchError(this.handleError));
        };
        //note: a data context is no longer connected
        //      and must be disabled
        LoginService.prototype.DisableDatacontext = function (dataContext, notificationMessage) {
            //note: first a check to see if there is actually any datacontexts available
            //      if none e.g. only the one we are disabling then we will need to log you out
            //      remember the "" datacontext will always be there, that's why the check starts at 2
            if (this.dataContext.length == 2) {
                alert(notificationMessage.ErrorMessage);
                this.logout();
                return;
            }
            //find the index so we can splice
            for (var i = 0; i < this.dataContext.length; i++) {
                if (this.dataContext[i].DataContextId === dataContext.DataContextId) {
                    this.dataContext.splice(i, 1);
                    dataContext.ConnectionStatus = "Not Connected";
                    dataContext.Token = null;
                    dataContext.RefreshToken = null;
                    dataContext.ServiceUri = null;
                    this.dataContextNotConnected.push(dataContext);
                    break;
                }
            }
            //note: notify of change to selected data context
            //note: we have more than 1 connected
            if (this.dataContext.length > 2) {
                this.selectedDataContext = undefined;
                this.defaultCompanyID = "";
                this.dataContextSubscription.next(undefined);
            }
            //note: we have exactly 1 connected
            //      1st one will always be the "" datacontext
            if (this.dataContext.length == 2) {
                this.dataContext[1].IsSelected = true;
                this.selectedDataContext = this.dataContext[1];
                this.defaultCompanyID = this.dataContext[1].CompanyID;
                this.dataContextSubscription.next(this.dataContext[1]);
            }
        };
        return LoginService;
    }(BaseService));
    LoginService.decorators = [
        { type: core.Injectable }
    ];
    LoginService.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: qmuzikAngularModelCore.AppGlobal },
        { type: router.Router },
        { type: AppManagementService }
    ]; };
    //sent to the oauth registration endpoint
    var RegistrationData = /** @class */ (function () {
        function RegistrationData() {
        }
        return RegistrationData;
    }());

    /**
     * Services for anyone required to work with data contexts
     */
    var DataContextService = /** @class */ (function (_super) {
        __extends(DataContextService, _super);
        function DataContextService(http, appGlobal, loginService) {
            var _this = 
            //constructor of inherited class must have this call 
            _super.call(this) || this;
            _this.http = http;
            _this.appGlobal = appGlobal;
            _this.loginService = loginService;
            return _this;
        }
        //note: retrieve all active data contexts from the authentication service
        DataContextService.prototype.GetDataContext = function (username) {
            this.username = username;
            var uri = this.appGlobal.apiURL + 'api/DataContextViews/GetDataContextViewsByUserName';
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('userName', username);
            return this.http.get(uri, {
                params: httpParams
            })
                .pipe(operators.catchError(this.handleError));
        };
        //note: retrieve a specific data context from the authentication service
        DataContextService.prototype.GetDataContextById = function (id) {
            var uri = this.appGlobal.apiURL + 'api/DataContextViews/';
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('id', id);
            return this.http.get(uri, {
                params: httpParams
            })
                .pipe(operators.catchError(this.handleError));
        };
        //note: return an observable of datacontexts (for all companies <> "")
        DataContextService.prototype.GetRetrievedDataContexts = function () {
            var dataContextFiltered = [];
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID !== "") {
                    dataContextFiltered.push(this.loginService.dataContext[i]);
                }
            }
            return rxjs.of(dataContextFiltered);
        };
        //note : selecting a object in the typeahead we need to
        //        "cast" it to the required type so the instanceof works
        DataContextService.prototype.AssignToType = function (item) {
            //must use assign here, otherwise instancof checks will not work
            return Object.assign(new qmuzikAngularModelCore.DataContext(), item);
        };
        //note:  locally run through datacontexts
        //       return the datacontext corresponding to the specified
        //       company id
        DataContextService.prototype.GetDataContextForCompanyId = function (companyID) {
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === companyID) {
                    return this.loginService.dataContext[i];
                }
            }
            //not found
            return null;
        };
        return DataContextService;
    }(BaseService));
    DataContextService.decorators = [
        { type: core.Injectable }
    ];
    DataContextService.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: qmuzikAngularModelCore.AppGlobal },
        { type: LoginService }
    ]; };

    var InitialisationService = /** @class */ (function (_super) {
        __extends(InitialisationService, _super);
        function InitialisationService(loginService, http, appGlobal, router) {
            var _this = _super.call(this) || this;
            _this.loginService = loginService;
            _this.http = http;
            _this.appGlobal = appGlobal;
            _this.router = router;
            _this.companyViews = new qmuzikAngularModelCore.CompanyViews();
            _this.companyWorkdays = new qmuzikAngularModelCore.CompanyWorkdays();
            _this.cachedViewProperties = new qmuzikAngularModelCore.CachedViewProperties();
            _this.cachedViewPropertiesSymbol = new qmuzikAngularModelCore.CachedViewPropertiesSymbol();
            _this.cachedViewRules = new qmuzikAngularModelCore.CompanyRules();
            _this.cachedViewNotifications = new qmuzikAngularModelCore.CompanyNotificationMessages();
            _this.companySystemConfiguration = new qmuzikAngularModelCore.CompanySystemConfiguration();
            //note: we expose this so the our validation base classes can inject it into Rule scripts
            _this.httpClient = http;
            //note: cannot inject in login service...circular reference
            //      login service requires access to companyViews
            _this.loginService.initialisationService = _this;
            return _this;
        }
        //note: we will use this resolver to retrieve all the initialisation data for a route/component
        InitialisationService.prototype.resolve = function (route, state) {
            return __awaiter(this, void 0, void 0, function () {
                var currentNav, viewInternalName, i;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            currentNav = this.router.getCurrentNavigation();
                            i = 0;
                            _a.label = 1;
                        case 1:
                            if (!(i < route.data['InternalName'].length)) return [3 /*break*/, 9];
                            //note: a different version from the one registered in app.module
                            //      we may have to mod this is more than one view
                            if (currentNav.extras && currentNav.extras.state && currentNav.extras.state.internalName) {
                                viewInternalName = currentNav.extras.state.internalName;
                            }
                            else {
                                viewInternalName = route.data['InternalName'][i];
                            }
                            if (!(this.cachedViewRules[viewInternalName] === undefined)) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.GetRules(viewInternalName).toPromise().then(function (result) {
                                    _this.InitialiseCompanyRules(result, viewInternalName);
                                })];
                        case 2:
                            _a.sent();
                            _a.label = 3;
                        case 3:
                            ;
                            if (!(this.cachedViewNotifications[viewInternalName] === undefined)) return [3 /*break*/, 5];
                            return [4 /*yield*/, this.GetNotificationMessages(viewInternalName).toPromise().then(function (result) {
                                    _this.InitialiseCompanyNotifications(result, viewInternalName);
                                })];
                        case 4:
                            _a.sent();
                            _a.label = 5;
                        case 5:
                            ;
                            if (!(this.cachedViewProperties[viewInternalName] === undefined)) return [3 /*break*/, 8];
                            return [4 /*yield*/, this.GetPropertyConfiguration(viewInternalName).toPromise().then(function (result) {
                                    _this.cachedViewProperties[viewInternalName] = result;
                                })];
                        case 6:
                            _a.sent();
                            if (!(currentNav.extras.state.SymbolInstanceId !== undefined && currentNav.extras.state.SymbolInstanceId !== null)) return [3 /*break*/, 8];
                            if (!(currentNav.extras.state.SymbolInstanceId > 0)) return [3 /*break*/, 8];
                            return [4 /*yield*/, this.GetPropertyConfigurationSymbol(viewInternalName, currentNav.extras.state.SymbolInstanceId).toPromise().then(function (result) {
                                    _this.cachedViewPropertiesSymbol[(viewInternalName + currentNav.extras.state.SymbolInstanceId.toString())] = result;
                                })];
                        case 7:
                            _a.sent();
                            _a.label = 8;
                        case 8:
                            i++;
                            return [3 /*break*/, 1];
                        case 9: return [2 /*return*/, true];
                    }
                });
            });
        };
        //note: retrieve the working days for all active data contexts
        //      we might want to limit result retrieved at some point (this can be done in the backend)
        InitialisationService.prototype.GetCompanyWorkdays = function () {
            var _this = this;
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === "") {
                    continue;
                }
                var headers = new http.HttpHeaders({
                    "CompanyID": this.loginService.dataContext[i].CompanyID
                });
                var observable = this.http.get(this.loginService.dataContext[i].ServiceUri + "api/Company_CalendarLibrary/GetCompany_CalendarFuture", {
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
                observable.subscribe(function (result) {
                    if (result.length > 0) {
                        _this.companyWorkdays[result[0].CompanyID] = result;
                    }
                });
            }
        };
        //note: we must be able to retrieve this for individual companies
        InitialisationService.prototype.GetCompanyWorkdaysForCompany = function (companyID) {
            return __awaiter(this, void 0, void 0, function () {
                var serviceUri, i, headers, observable;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            serviceUri = "";
                            for (i = 0; i < this.loginService.dataContext.length; i++) {
                                if (this.loginService.dataContext[i].CompanyID === companyID) {
                                    serviceUri = this.loginService.dataContext[i].ServiceUri;
                                    break;
                                }
                            }
                            headers = new http.HttpHeaders({
                                "CompanyID": companyID
                            });
                            observable = this.http.get(serviceUri + "api/Company_CalendarLibrary/GetCompany_CalendarFuture", {
                                headers: headers
                            })
                                .pipe(operators.catchError(this.handleError));
                            return [4 /*yield*/, observable.toPromise().then(function (result) {
                                    if (result.length > 0) {
                                        _this.companyWorkdays[companyID] = result;
                                    }
                                })];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        //note: retrieve the erp system configuration settings per company
        InitialisationService.prototype.GetSystemConfigurationSettings = function () {
            var _this = this;
            var observables = [];
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === "") {
                    continue;
                }
                var headers = new http.HttpHeaders({
                    "CompanyID": this.loginService.dataContext[i].CompanyID
                });
                var observable = this.http.get(this.loginService.dataContext[i].ServiceUri + "api/SystemConfigurationSettingLibrary", {
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
                // bit
                // char
                // decimal(12,3)
                // decimal(13,2)
                // decimal(4,2)
                // decimal(5,2)
                // decimal(5,5)
                // decimal(7,2)
                // smalldatetime
                // smallint
                // tinyint
                // varchar(10)
                // varchar(15)
                // varchar(255)
                // varchar(6)
                observable.subscribe(function (result) {
                    for (var i = 0; i < result.length; i++) {
                        if (_this.companySystemConfiguration[result[i].CompanyID] === undefined) {
                            _this.companySystemConfiguration[result[i].CompanyID] = new qmuzikAngularModelCore.SystemConfiguration();
                        }
                        _this.companySystemConfiguration[result[i].CompanyID][result[i].ConfigField.replace(/_/g, '')] = [result[i].ConfigValue][0];
                    }
                });
            }
        };
        //note: retrieve the erp system configuration settings for individual companies
        InitialisationService.prototype.GetSystemConfigurationSettingsForCompany = function (companyID) {
            return __awaiter(this, void 0, void 0, function () {
                var serviceUri, i, headers, observable;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            serviceUri = "";
                            for (i = 0; i < this.loginService.dataContext.length; i++) {
                                if (this.loginService.dataContext[i].CompanyID === companyID) {
                                    serviceUri = this.loginService.dataContext[i].ServiceUri;
                                    break;
                                }
                            }
                            headers = new http.HttpHeaders({
                                "CompanyID": companyID
                            });
                            observable = this.http.get(serviceUri + "api/SystemConfigurationSettingLibrary", {
                                headers: headers
                            })
                                .pipe(operators.catchError(this.handleError));
                            return [4 /*yield*/, observable.toPromise().then(function (result) {
                                    for (var i = 0; i < result.length; i++) {
                                        if (_this.companySystemConfiguration[companyID] === undefined) {
                                            _this.companySystemConfiguration[companyID] = new qmuzikAngularModelCore.SystemConfiguration();
                                        }
                                        _this.companySystemConfiguration[companyID][result[i].ConfigField.replace(/_/g, '')] = [result[i].ConfigValue][0];
                                    }
                                })];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        //note: this will return all views that must be available in a user's menu
        //      it will be returned per company
        //      question: what if you have access on one company to a view, but not another
        InitialisationService.prototype.GetMyViews = function () {
            var _this = this;
            var observables = [];
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === "") {
                    continue;
                }
                var headers = new http.HttpHeaders({
                    "CompanyID": this.loginService.dataContext[i].CompanyID
                });
                var observable = this.http.get(this.loginService.dataContext[i].ServiceUri + "api/GetMyViews/GetGetMyViews", {
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
                observables.push(observable);
            }
            return rxjs.forkJoin(observables).pipe(operators.map(function (data) {
                return _this.FormatObserveablesArray(data);
            }));
        };
        //note: this will return all views that must be available in a user's menu
        //      it will be returned per company
        //      question: what if you have access on one company to a view, but not another
        InitialisationService.prototype.GetMyViewsForCompany = function (companyID) {
            var serviceUri = "";
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === companyID) {
                    serviceUri = this.loginService.dataContext[i].ServiceUri;
                    break;
                }
            }
            var headers = new http.HttpHeaders({
                "CompanyID": companyID
            });
            var observable = this.http.get(serviceUri + "api/GetMyViews/GetGetMyViews", {
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
            return observable;
        };
        //note: retrieve the configuration for a view
        InitialisationService.prototype.GetPropertyConfiguration = function (viewName) {
            var _this = this;
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('internalName', viewName);
            var observables = [];
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === "") {
                    continue;
                }
                var headers = new http.HttpHeaders({
                    "CompanyID": this.loginService.dataContext[i].CompanyID
                });
                var observable = this.http.get(this.loginService.dataContext[i].ServiceUri + "api/GetMyViewProperties/GetGetMyViewPropertiesByInternalName", {
                    params: httpParams,
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
                observables.push(observable);
            }
            return rxjs.forkJoin(observables).pipe(operators.map(function (data) {
                return _this.FormatObserveablesArray(data);
            }));
        };
        //note: retrieve the configuration for a view for a specific company
        InitialisationService.prototype.GetPropertyConfigurationForCompany = function (viewName, companyID) {
            var serviceUri = "";
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === companyID) {
                    serviceUri = this.loginService.dataContext[i].ServiceUri;
                    break;
                }
            }
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('internalName', viewName);
            var headers = new http.HttpHeaders({
                "CompanyID": companyID
            });
            var observable = this.http.get(serviceUri + "api/GetMyViewProperties/GetGetMyViewPropertiesByInternalName", {
                params: httpParams,
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
            return observable;
        };
        //note: retrieve the configuration for a view connected to a symbol in qt
        InitialisationService.prototype.GetPropertyConfigurationSymbol = function (viewName, symbolInstanceId) {
            var _this = this;
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('internalName', viewName);
            var observables = [];
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === "") {
                    continue;
                }
                var headers = new http.HttpHeaders({
                    "CompanyID": this.loginService.dataContext[i].CompanyID,
                    "InstanceInformation": ['0', symbolInstanceId.toString(), '0', '', 'False', '0']
                });
                var observable = this.http.get(this.loginService.dataContext[i].ServiceUri + "api/GetMyViewProperties/GetGetMyViewPropertiesBySymbolTemplateId", {
                    params: httpParams,
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
                observables.push(observable);
            }
            return rxjs.forkJoin(observables).pipe(operators.map(function (data) {
                return _this.FormatObserveablesArray(data);
            }));
        };
        //note: retrieve the rules for a view
        //      this must be optimised. if retrieved once for a session it
        //      won't be retreived again, just returned
        InitialisationService.prototype.GetRules = function (viewName) {
            var _this = this;
            //note: if in production no rules will EVER be allowed to be "eval'ed": security risk + minification issues
            if (this.appGlobal.production) {
                return new rxjs.Observable(null);
            }
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('internalName', viewName);
            var observables = [];
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === "") {
                    continue;
                }
                var headers = new http.HttpHeaders({
                    "CompanyID": this.loginService.dataContext[i].CompanyID
                });
                var observable = this.http.get(this.loginService.dataContext[i].ServiceUri + "api/GetMyViewRules/GetGetMyViewRulesByInternalName", {
                    params: httpParams,
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
                observables.push(observable);
            }
            return rxjs.forkJoin(observables).pipe(operators.map(function (data) {
                return _this.FormatObserveablesArray(data);
            }));
        };
        //note: retrieve the rules for a view for a specific company
        InitialisationService.prototype.GetRulesForCompany = function (viewName, companyID) {
            //note: if in production no rules will EVER be allowed to be "eval'ed": security risk + minification issues
            // if(this.appGlobal.production){
            //   return new Observable(null);
            // }
            var serviceUri = "";
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === companyID) {
                    serviceUri = this.loginService.dataContext[i].ServiceUri;
                    break;
                }
            }
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('internalName', viewName);
            var observables = [];
            var headers = new http.HttpHeaders({
                "CompanyID": companyID
            });
            var observable = this.http.get(serviceUri + "api/GetMyViewRules/GetGetMyViewRulesByInternalName", {
                params: httpParams,
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
            return observable;
        };
        //note: retrieve the notifications for a view
        InitialisationService.prototype.GetNotificationMessages = function (viewName) {
            var _this = this;
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('internalName', viewName);
            var observables = [];
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === "") {
                    continue;
                }
                var headers = new http.HttpHeaders({
                    "CompanyID": this.loginService.dataContext[i].CompanyID
                });
                var observable = this.http.get(this.loginService.dataContext[i].ServiceUri + "api/GetMyViewNotifications/GetGetMyViewNotificationsByInternalName", {
                    params: httpParams,
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
                observables.push(observable);
            }
            return rxjs.forkJoin(observables).pipe(operators.map(function (data) {
                //#region ensure "no results" will also have something in the cache
                for (var i = 0; i < _this.loginService.dataContext.length; i++) {
                    if (_this.loginService.dataContext[i].CompanyID === "") {
                        continue;
                    }
                    //note: add the company
                    if (_this.cachedViewNotifications[_this.loginService.dataContext[i].CompanyID] === undefined) {
                        _this.cachedViewNotifications[_this.loginService.dataContext[i].CompanyID] = {};
                    }
                    //note: add the view
                    if (_this.cachedViewNotifications[_this.loginService.dataContext[i].CompanyID][viewName] === undefined) {
                        _this.cachedViewNotifications[_this.loginService.dataContext[i].CompanyID][viewName] = {};
                    }
                }
                //#endregion ensure "no results" will also have something in the cache
                return _this.FormatObserveablesArray(data);
            }));
        };
        //note: retrieve the notifications for a view
        InitialisationService.prototype.GetNotificationMessagesForCompany = function (viewName, companyID) {
            var serviceUri = "";
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === companyID) {
                    serviceUri = this.loginService.dataContext[i].ServiceUri;
                    break;
                }
            }
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('internalName', viewName);
            var headers = new http.HttpHeaders({
                "CompanyID": companyID
            });
            var observable = this.http.get(serviceUri + "api/GetMyViewNotifications/GetGetMyViewNotificationsByInternalName", {
                params: httpParams,
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
            return observable;
        };
        //note: retrieve the notification messagas for the system
        InitialisationService.prototype.GetNotificationMessagesSystem = function () {
            var _this = this;
            var observables = [];
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === "") {
                    continue;
                }
                var headers = new http.HttpHeaders({
                    "CompanyID": this.loginService.dataContext[i].CompanyID
                });
                var observable = this.http.get(this.loginService.dataContext[i].ServiceUri + "api/GetMyViewNotifications/GetGetMyViewNotificationsByIsSystem", {
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
                observables.push(observable);
            }
            return rxjs.forkJoin(observables).pipe(operators.map(function (data) {
                return _this.FormatObserveablesArray(data);
            }));
        };
        //note: retrieve the notification messagas for a specified company
        InitialisationService.prototype.GetNotificationMessagesSystemForCompany = function (companyID) {
            return __awaiter(this, void 0, void 0, function () {
                var serviceUri, i, headers, observable;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            serviceUri = "";
                            for (i = 0; i < this.loginService.dataContext.length; i++) {
                                if (this.loginService.dataContext[i].CompanyID === companyID) {
                                    serviceUri = this.loginService.dataContext[i].ServiceUri;
                                    break;
                                }
                            }
                            headers = new http.HttpHeaders({
                                "CompanyID": companyID
                            });
                            observable = this.http.get(serviceUri + "api/GetMyViewNotifications/GetGetMyViewNotificationsByIsSystem", {
                                headers: headers
                            })
                                .pipe(operators.catchError(this.handleError));
                            return [4 /*yield*/, observable.toPromise().then(function (result) {
                                    _this.InitialiseCompanyNotifications(result, 'system');
                                })];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        //note: initialise the default viewstate properties
        //      on creation of a new instance of the component
        InitialisationService.prototype.Initialise = function (viewName, symbolInstanceId) {
            var viewState = {};
            //call on the rest api to retrieve all the control state
            //properties set up in the database for this view
            for (var i = 0; i < this.viewProperties.length; i++) {
                if (viewState[this.viewProperties[i].Company_ID] === undefined) {
                    viewState[this.viewProperties[i].Company_ID] = {};
                }
                if (viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName] === undefined) {
                    viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName] = {};
                }
                if (viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] === undefined) {
                    if (this.viewProperties[i].DataType === "boolean") {
                        if (this.viewProperties[i].Value === "1") {
                            viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = true;
                        }
                        else {
                            viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = false;
                        }
                    }
                    else if ((this.viewProperties[i].DataType === "number") || (this.viewProperties[i].DataType === "int")) {
                        //note: get rid of trailing 0 decimals by 1st converting to string, then back to float
                        var num = void 0;
                        if (this.viewProperties[i].Value) {
                            num = parseFloat(this.viewProperties[i].Value.toString());
                        }
                        viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = num;
                    }
                    else {
                        viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = this.viewProperties[i].Value;
                    }
                }
                //#region symbol properties override
                // if(symbolInstanceId !== undefined && symbolInstanceId !== null && symbolInstanceId > 0){
                //   for(var j = 0; j < this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())].length; j++){
                //     if(
                //       this.viewProperties[i].Company_ID === this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID
                //         &&
                //       this.viewProperties[i].PropertyName === this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName   )
                //     {
                //       //note: we found a property on the symbol that we should override on standard
                //       if(this.viewProperties[i].DataType === "boolean"){
                //         if(this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Value === "1"){
                //           viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = true;
                //         }
                //         else{
                //           viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = false;
                //         }
                //       }
                //       else 
                //         if(this.viewProperties[i].DataType === "number"){
                //           let num: number = this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Value;
                //           viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = num;
                //         }
                //       else
                //         {
                //           viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Value;
                //         }  
                //       break;  
                //     }
                //   }
                // }
                //#endregion symbol properties override
            }
            //#region symbol properties
            if (symbolInstanceId !== undefined && symbolInstanceId !== null && symbolInstanceId > 0) {
                for (var j = 0; j < this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())].length; j++) {
                    //note: property name
                    if (viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName] === undefined) {
                        viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName] = {};
                    }
                    //note: property key
                    if (viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] === undefined) {
                        viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] = {};
                    }
                    //note: we found a property on the symbol that we should override on standard
                    if (this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].DataType === "boolean") {
                        if (this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Value === "1") {
                            viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] = true;
                        }
                        else {
                            viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] = false;
                        }
                    }
                    else if (this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].DataType === "number") {
                        var num = this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Value;
                        viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] = num;
                    }
                    else {
                        viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] = this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Value;
                    }
                }
            }
            //#endregion symbol properties
            return viewState;
        };
        //note: initialise the default viewstate properties by adding on to existing view state
        InitialisationService.prototype.InitialiseWithViewState = function (viewName, symbolInstanceId, viewState) {
            //call on the rest api to retrieve all the control state
            //properties set up in the database for this view
            for (var i = 0; i < this.viewProperties.length; i++) {
                if (viewState[this.viewProperties[i].Company_ID] === undefined) {
                    viewState[this.viewProperties[i].Company_ID] = {};
                }
                if (viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName] === undefined) {
                    viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName] = {};
                }
                if (viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] === undefined) {
                    if (this.viewProperties[i].DataType === "boolean") {
                        if (this.viewProperties[i].Value === "1") {
                            viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = true;
                        }
                        else {
                            viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = false;
                        }
                    }
                    else if (this.viewProperties[i].DataType === "number") {
                        var num = this.viewProperties[i].Value;
                        viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = num;
                    }
                    else {
                        viewState[this.viewProperties[i].Company_ID][this.viewProperties[i].PropertyName][this.viewProperties[i].Key] = this.viewProperties[i].Value;
                    }
                }
                //#region symbol properties
                if (symbolInstanceId !== undefined && symbolInstanceId !== null && symbolInstanceId > 0) {
                    for (var j = 0; j < this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())].length; j++) {
                        //note: property name
                        if (viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName] === undefined) {
                            viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName] = {};
                        }
                        //note: property key
                        if (viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] === undefined) {
                            viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] = {};
                        }
                        //note: we found a property on the symbol that we should override on standard
                        if (this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].DataType === "boolean") {
                            if (this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Value === "1") {
                                viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] = true;
                            }
                            else {
                                viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] = false;
                            }
                        }
                        else if (this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].DataType === "number") {
                            var num = this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Value;
                            viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] = num;
                        }
                        else {
                            viewState[this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Company_ID][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].PropertyName][this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Key] = this.cachedViewPropertiesSymbol[(viewName + symbolInstanceId.toString())][j].Value;
                        }
                    }
                }
                //#endregion symbol properties
            }
            return viewState;
        };
        //note: initialise rules
        InitialisationService.prototype.InitialiseCompanyRules = function (viewRules, viewName) {
            if ((viewRules === undefined) || (viewRules === null)) {
                return;
            }
            for (var j = 0; j < this.loginService.dataContext.length; j++) {
                if (this.loginService.dataContext[j].CompanyID === "") {
                    continue;
                }
                //note: add the company
                if (this.cachedViewRules[this.loginService.dataContext[j].CompanyID] === undefined) {
                    this.cachedViewRules[this.loginService.dataContext[j].CompanyID] = {};
                }
                //note: add the view
                if (this.cachedViewRules[this.loginService.dataContext[j].CompanyID][viewName] === undefined) {
                    this.cachedViewRules[this.loginService.dataContext[j].CompanyID][viewName] = {};
                }
            }
            //loop and add to the cached company rules
            for (var i = 0; i < viewRules.length; i++) {
                //note: add the rule
                if (this.cachedViewRules[viewRules[i].Company_ID][viewName][viewRules[i].Name] === undefined) {
                    var rule = new qmuzikAngularModelCore.Rule();
                    rule.Name = viewRules[i].Name;
                    rule.Sequence = viewRules[i].Sequence;
                    rule.ShouldAbortError = viewRules[i].ShouldAbortError;
                    rule.ShouldAbortFailure = viewRules[i].ShouldAbortFailure;
                    rule.ShouldRollbackOnError = viewRules[i].ShouldRollbackOnError;
                    rule.ShouldRollbackOnFailure = viewRules[i].ShouldRollbackOnFailure;
                    if (viewRules[i].SystemHook !== null) {
                        rule.SystemHook = this.GetSystemHooksFromStringArray(viewRules[i].SystemHook.split(','));
                    }
                    else {
                        rule.SystemHook = null;
                    }
                    rule.TriggerProperties = viewRules[i].TriggerProperties;
                    rule.RuleScript = viewRules[i].RuleScript;
                    rule.TrueResultScript = viewRules[i].TrueResultScript;
                    rule.FalseResultScript = viewRules[i].FalseResultScript;
                    rule.ViewStateRule = viewRules[i].ViewStateRule;
                    rule.ModelStateRule = viewRules[i].ModelStateRule;
                    rule.FriendlyName = viewRules[i].FriendlyName;
                    rule.Active = viewRules[i].Active;
                    rule.Description = viewRules[i].Description;
                    if (viewRules[i].ExecuteRules !== null) {
                        rule.ExecuteRules = viewRules[i].ExecuteRules.split(',');
                    }
                    else {
                        rule.ExecuteRules = null;
                    }
                    this.cachedViewRules[viewRules[i].Company_ID][viewName][viewRules[i].Name] = rule;
                }
            }
        };
        //note: initialise notification
        InitialisationService.prototype.InitialiseCompanyNotifications = function (viewNotifications, viewName) {
            //loop and add to the cached company Notifications
            for (var i = 0; i < viewNotifications.length; i++) {
                //note: add the company
                if (this.cachedViewNotifications[viewNotifications[i].Company_ID] === undefined) {
                    this.cachedViewNotifications[viewNotifications[i].Company_ID] = {};
                }
                //note: add the view
                if (this.cachedViewNotifications[viewNotifications[i].Company_ID][viewName] === undefined) {
                    this.cachedViewNotifications[viewNotifications[i].Company_ID][viewName] = {};
                }
                //note: add the notification message
                if (this.cachedViewNotifications[viewNotifications[i].Company_ID][viewName][viewNotifications[i].NotificationId] === undefined) {
                    var notificationMessage = new qmuzikAngularModelCore.NotificationMessage();
                    notificationMessage.ErrorMessage = viewNotifications[i].ErrorMessage;
                    notificationMessage.Id = viewNotifications[i].NotificationId;
                    notificationMessage.IsError = viewNotifications[i].IsError;
                    notificationMessage.IsWarning = viewNotifications[i].IsWarning;
                    notificationMessage.IsInformation = viewNotifications[i].IsInformation;
                    this.cachedViewNotifications[viewNotifications[i].Company_ID][viewName][viewNotifications[i].NotificationId] = notificationMessage;
                }
            }
        };
        //note: get system hook enum array
        InitialisationService.prototype.GetSystemHooksFromStringArray = function (systemHooksString) {
            var systemHooks = [];
            for (var i = 0; i < systemHooksString.length; i++) {
                systemHooks.push(qmuzikAngularModelCore.SystemHooks[systemHooksString[i]]);
            }
            return systemHooks;
        };
        //note: route to the correct view 
        InitialisationService.prototype.Navigate = function (view, target) {
            var _this = this;
            if (this.cachedViewProperties[view.InternalName] === undefined) {
                this.GetPropertyConfiguration(view.InternalName).subscribe(function (result) {
                    _this.cachedViewProperties[view.InternalName] = result;
                    _this.viewProperties = result;
                    //note: load the rules for this view
                    if (_this.cachedViewRules[view.InternalName] === undefined) {
                        _this.GetRules(view.InternalName).subscribe(function (result) {
                            _this.InitialiseCompanyRules(result, view.InternalName);
                            //note: load the notifications for this view
                            if (_this.cachedViewNotifications[view.InternalName] === undefined) {
                                _this.GetNotificationMessages(view.InternalName).subscribe(function (result) {
                                    _this.InitialiseCompanyNotifications(result, view.InternalName);
                                    if (target === '') {
                                        _this.router.navigate([view.Route], { state: { viewFriendlyName: view.Name, internalName: view.InternalName } });
                                    }
                                    if (target === 'leftregion') {
                                        _this.router.navigate([{ outlets: { leftregion: [view.Route] } }], { state: { viewFriendlyName: view.Name, internalName: view.InternalName } });
                                    }
                                });
                            }
                        });
                    }
                });
            }
            else {
                if (target === '') {
                    this.router.navigate([view.Route], { state: { viewFriendlyName: view.Name, internalName: view.InternalName } });
                }
                if (target === 'leftregion') {
                    this.router.navigate([{ outlets: { leftregion: [view.Route] } }], { state: { viewFriendlyName: view.Name, internalName: view.InternalName } });
                }
            }
        };
        return InitialisationService;
    }(BaseService));
    InitialisationService.decorators = [
        { type: core.Injectable }
    ];
    InitialisationService.ctorParameters = function () { return [
        { type: LoginService },
        { type: http.HttpClient },
        { type: qmuzikAngularModelCore.AppGlobal },
        { type: router.Router }
    ]; };

    var NotificationService = /** @class */ (function (_super) {
        __extends(NotificationService, _super);
        function NotificationService(initialisationService) {
            var _this = _super.call(this) || this;
            _this.initialisationService = initialisationService;
            _this.notificationMessages = {};
            return _this;
        }
        //note: given a notification id, return it's info
        NotificationService.prototype.GetNotification = function (notificationId, notificationVariables, companyID, name) {
            var notificationMessage = new qmuzikAngularModelCore.NotificationMessage();
            //Object.assign(notificationMessage, this.notificationMessages[companyID][notificationId])
            Object.assign(notificationMessage, this.initialisationService.cachedViewNotifications[companyID][name][notificationId]);
            var keys = Object.keys(notificationVariables);
            notificationMessage.ErrorMessage = this.ReplaceVariables(notificationMessage.ErrorMessage, notificationVariables, keys);
            return notificationMessage;
        };
        //note: replace variables in message
        NotificationService.prototype.ReplaceVariables = function (errorMessage, notificationVariables, keys) {
            for (var i = 0; i < keys.length; i++) {
                errorMessage = errorMessage.replace(("~~" + keys[i]), notificationVariables[keys[i]]);
            }
            return errorMessage;
        };
        //note: return all notifications linked to a view for a Company
        //this may be a combination of messages from the database, but also maybe locally saved? To decrease data req...
        NotificationService.prototype.GetNotifications = function (viewName) {
            // this.notificationMessages = {
            //   QT: {
            //     1: {
            //       Id: 1,
            //       ErrorMessage: "You are exceeding the maximum allowed characters by ~~NumberCharacters",
            //       IsError: true,
            //       IsWarning: false,
            //       IsInformation: false        
            //     },      
            //     2: {
            //       Id: 2,
            //       ErrorMessage: "You require ~~NumberCharacters more characters",
            //       IsError: true,
            //       IsWarning: false,
            //       IsInformation: false        
            //     },  
            //     3: {
            //       Id: 3,
            //       ErrorMessage: "This is a required field",
            //       IsError: false,
            //       IsWarning: false,
            //       IsInformation: true        
            //     },     
            //     4: {
            //       Id: 4,
            //       ErrorMessage: "The minimum value allowed is ~~MinimumValue",
            //       IsError: true,
            //       IsWarning: false,
            //       IsInformation: false        
            //     }, 
            //     5: {
            //       Id: 5,
            //       ErrorMessage: "The maximum value allowed is ~~MaximumValue",
            //       IsError: true,
            //       IsWarning: false,
            //       IsInformation: false        
            //     },                            
            //     100000: {
            //       Id: 100000,
            //       ErrorMessage: "Description may only be 30 characters",
            //       IsError: true,
            //       IsWarning: false,
            //       IsInformation: false        
            //     },
            //   },
            //   QMC: {
            //     1: {
            //       Id: 1,
            //       ErrorMessage: "You are exceeding the maximum allowed characters by ~~NumberCharacters",
            //       IsError: true,
            //       IsWarning: false,
            //       IsInformation: false        
            //     },      
            //     2: {
            //       Id: 2,
            //       ErrorMessage: "You require ~~NumberCharacters more characters",
            //       IsError: true,
            //       IsWarning: false,
            //       IsInformation: false        
            //     },  
            //     3: {
            //       Id: 3,
            //       ErrorMessage: "This is a required field",
            //       IsError: false,
            //       IsWarning: false,
            //       IsInformation: true        
            //     },     
            //     4: {
            //       Id: 4,
            //       ErrorMessage: "The minimum value allowed is ~~MinimumValue",
            //       IsError: true,
            //       IsWarning: false,
            //       IsInformation: false        
            //     }, 
            //     5: {
            //       Id: 5,
            //       ErrorMessage: "The maximum value allowed is ~~MaximumValue",
            //       IsError: true,
            //       IsWarning: false,
            //       IsInformation: false        
            //     },                            
            //     100000: {
            //       Id: 100000,
            //       ErrorMessage: "Description may only be 30 characters",
            //       IsError: true,
            //       IsWarning: false,
            //       IsInformation: false        
            //     },
            //   }      
            // };
        };
        return NotificationService;
    }(BaseService));
    NotificationService.decorators = [
        { type: core.Injectable }
    ];
    NotificationService.ctorParameters = function () { return [
        { type: InitialisationService }
    ]; };

    var Interceptor = /** @class */ (function () {
        function Interceptor(loginService, appManagementService, dataContextService, notificationService) {
            this.loginService = loginService;
            this.appManagementService = appManagementService;
            this.dataContextService = dataContextService;
            this.notificationService = notificationService;
            this.refreshSubject = new rxjs.Subject();
        }
        //note: fired on every http request
        Interceptor.prototype.intercept = function (req, next) {
            var _this = this;
            //note: here we have to check what is the base uri that is targeted
            //      obtain the correct token to append (since each data context will have it's own token)
            var authToken = null;
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                //note: check if we find a datacontext for the company specified in the header
                if (req.headers.get("CompanyID") === this.loginService.dataContext[i].CompanyID) {
                    authToken = this.loginService.dataContext[i].Token;
                    //note: token for datacontext is null for some reason
                    //#region no token
                    if (authToken === null) {
                        return next.handle(req)
                            .pipe(operators.tap(function (event) {
                            if (event instanceof http.HttpResponse) {
                            }
                            return event;
                        }));
                    }
                    //#endregion no token 
                    //note: targeting the authorisation web service
                    //#region authorisation service
                    if (this.loginService.dataContext[i].CompanyID === '') {
                        var authReq = req.clone({
                            headers: req.headers.set('Authorization', 'Bearer ' + authToken)
                        });
                        return next.handle(authReq)
                            .pipe(operators.tap(function (event) {
                            if (event instanceof http.HttpResponse) {
                            }
                            return event;
                        }));
                    }
                    //#endregion authorisation service
                    //note: targeting the specific datacontext web service
                    else {
                        var authReq = void 0;
                        authReq = req.clone({
                            headers: req.headers.set('ApiToken', authToken)
                        });
                        //note: we will use this header value to pass any additional information to the web api service
                        if (this.appManagementService.extraHeaderValue) {
                            authReq = authReq.clone({
                                headers: authReq.headers.set('ExtraHeaderValue', this.appManagementService.extraHeaderValue)
                            });
                        }
                        return next.handle(authReq)
                            .pipe(operators.retry(1), //note: retry each failed call by default once...this will help with bad networks etc.
                        operators.tap(function (event) {
                            if (event instanceof http.HttpResponse) {
                                //note: successful execution of http request
                                //      clear any errors that we previously had for this company/context
                            }
                            if (event instanceof http.HttpErrorResponse) {
                            }
                            return event;
                        }), operators.catchError(function (error, caught) {
                            var companyID = req.headers.get("CompanyID");
                            var dataContext = _this.dataContextService.GetDataContextForCompanyId(companyID);
                            //note: our interceptor should replace the error handling
                            //      in the base service. it will also check for token
                            //      epiry. If token has expired it will use the refesh token
                            //      to obtain a new authorisation token.
                            if (error instanceof http.HttpErrorResponse) {
                                //note: request from the header the reason code 
                                var invalidReasonCode = error.headers.get("InvalidReasonCode"); //E: Expired
                                if (error.status
                                    &&
                                        error.status === 401 //note: Not Authorised
                                    &&
                                        invalidReasonCode === "E") {
                                    //note: we don't want to raise an error here, just ignore
                                    //      and let the refresh token take care of the issue
                                    // let notificationMessage: NotificationMessage = new NotificationMessage();
                                    // notificationMessage.Id = 0;
                                    // notificationMessage.IsError = true;
                                    // notificationMessage.ErrorMessage = error.message;
                                    // this.appManagementService.globalErrors.push(notificationMessage);
                                    for (var i = 0; i < _this.loginService.dataContext.length; i++) {
                                        if (_this.loginService.dataContext[i].CompanyID === companyID) {
                                            return _this.handleTokenExpired(_this.loginService.dataContext[i], i).pipe(operators.switchMap(function () {
                                                return next.handle(_this.updateHeader(req, i));
                                            }));
                                        }
                                    }
                                }
                                else if ((error.status !== undefined)
                                    &&
                                        error.status === 0 //note: net::ERR_CONNECTION_REFUSED...typically 1. web service offline 2. no network                 
                                ) {
                                    //note: inform the datacontext
                                    //note: log to our global error list so the user receives information
                                    //      about the error
                                    var notificationVariable = new qmuzikAngularModelCore.NotificationVariable();
                                    notificationVariable.DataContextDescription = dataContext.Description;
                                    _this.appManagementService.AddGlobalError(_this.notificationService.GetNotification(10, notificationVariable, companyID, "system"));
                                    //note: return EMPTY will not emit anything
                                    //      forkjoin requires something to be emitted.
                                    //      this is important where one of our forkjoin streams contain 
                                    //      errors, but the rest not
                                    //  
                                    //      impersonate a successful response
                                    return rxjs.of(new http.HttpResponse({ status: 200 }));
                                }
                                else if ((error.status !== undefined)
                                    &&
                                        error.status === 500 //note: Internal Server Error e.g. any backend/qmuzik error              
                                ) {
                                    //note: this must be thrown so that the we can display relevant error in the view
                                    //      for now, this is the only place I will throw the error
                                    return rxjs.throwError(error);
                                }
                                else {
                                    var notificationMessage_1 = new qmuzikAngularModelCore.NotificationMessage();
                                    notificationMessage_1.Id = 0;
                                    notificationMessage_1.IsError = true;
                                    notificationMessage_1.ErrorMessage = error.message;
                                    _this.appManagementService.globalErrors.push(notificationMessage_1);
                                    //note: we have an HttpErrorResponse, but it is not expiry
                                    //      what to do?
                                    return rxjs.of(new http.HttpResponse({ status: 200 }));
                                }
                            }
                            else {
                                //note: this is not an http error
                                var notificationMessage_2 = new qmuzikAngularModelCore.NotificationMessage();
                                notificationMessage_2.Id = 0;
                                notificationMessage_2.IsError = true;
                                notificationMessage_2.ErrorMessage = error.message;
                                _this.appManagementService.globalErrors.push(notificationMessage_2);
                                return rxjs.of(new http.HttpResponse({ status: 200 }));
                            }
                            //note: log the error as a global error
                            //      we will handle all http errors ourselves 
                            //      return success, e.g. handled
                            var notificationMessage = new qmuzikAngularModelCore.NotificationMessage();
                            notificationMessage.Id = 0;
                            notificationMessage.IsError = true;
                            notificationMessage.ErrorMessage = error.message;
                            _this.appManagementService.globalErrors.push(notificationMessage);
                            return rxjs.of(new http.HttpResponse({ status: 200 }));
                        }));
                    }
                }
            }
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (req.url.indexOf(this.loginService.dataContext[i].ServiceUri) > -1) {
                    //found:
                    authToken = this.loginService.dataContext[i].Token;
                    if (authToken === null) {
                        return next.handle(req)
                            .pipe(operators.tap(function (event) {
                            if (event instanceof http.HttpResponse) {
                            }
                            return event;
                        }));
                    }
                    if (this.loginService.dataContext[i].CompanyID === '') {
                        var authReq = req.clone({
                            headers: req.headers.set('Authorization', 'Bearer ' + authToken)
                        });
                        return next.handle(authReq)
                            .pipe(operators.tap(function (event) {
                            if (event instanceof http.HttpResponse) {
                            }
                            return event;
                        }));
                    }
                    else {
                        var authReq = req.clone({
                            headers: req.headers.set('ApiToken', authToken)
                        });
                        return next.handle(authReq)
                            .pipe(operators.tap(function (event) {
                            if (event instanceof http.HttpResponse) {
                            }
                            return event;
                        }));
                    }
                }
            }
            //nothing found: re-route to the login page (maybe with message)
            //alert('No data context found for: ' + req.url);
            return next.handle(req);
        };
        //note: this is called when a token has expired and needs to be refreshed
        Interceptor.prototype.handleTokenExpired = function (dataContext, i) {
            var _this = this;
            this.refreshSubject.subscribe({
                complete: function () {
                    _this.refreshSubject = new rxjs.Subject();
                }
            });
            if (this.refreshSubject.observers.length === 1) {
                //note: refresh the token
                this.loginService.getTokenWithRefreshToken(dataContext).subscribe({
                    next: (function (i, result) {
                        //note: here we must update the datacontext so that future api calls will use the new token
                        if (result !== null) {
                            _this.loginService.dataContext[i].Token = result.Token;
                            _this.loginService.dataContext[i].RefreshToken = result.RefreshToken;
                            //note: successfully retrieved the token. 
                            //      this re-issues the httprequest (switchmap)
                            _this.refreshSubject.next();
                        }
                        else {
                            //note: we could not get a refresh token for some reason
                            //      the auth token is not invalid and the data context must be disabled
                            var notificationVariable = new qmuzikAngularModelCore.NotificationVariable();
                            notificationVariable.DataContextDescription = dataContext.Description;
                            _this.appManagementService.AddGlobalError(_this.notificationService.GetNotification(11, notificationVariable, _this.loginService.dataContext[i].CompanyID, "system"));
                            _this.loginService.DisableDatacontext(_this.loginService.dataContext[i], _this.notificationService.GetNotification(12, {}, dataContext.CompanyID, "system"));
                        }
                    }).bind(undefined, i),
                    error: function (result) {
                        //note: an error occurred trying to get the new token with the refresh token
                        var notificationVariable = new qmuzikAngularModelCore.NotificationVariable();
                        notificationVariable.DataContextDescription = dataContext.Description;
                        _this.appManagementService.AddGlobalError(_this.notificationService.GetNotification(11, notificationVariable, _this.loginService.dataContext[i].CompanyID, "system"));
                        _this.loginService.DisableDatacontext(_this.loginService.dataContext[i], _this.notificationService.GetNotification(12, {}, dataContext.CompanyID, "system"));
                    },
                    complete: function () {
                        //note: this resets the refreshsubject
                        _this.refreshSubject.complete();
                    }
                });
            }
            return this.refreshSubject;
        };
        //note: update the header with the new token before being sent
        Interceptor.prototype.updateHeader = function (req, i) {
            var authToken = this.loginService.dataContext[i].Token;
            //#region don't delete
            //const clonedRequest = req.clone({ setHeaders: { Authorization: 'Bearer 123' } });
            //#endregion don't delete
            req = req.clone({
                headers: req.headers.set('ApiToken', authToken)
            });
            return req;
        };
        return Interceptor;
    }());
    Interceptor.decorators = [
        { type: core.Injectable }
    ];
    Interceptor.ctorParameters = function () { return [
        { type: LoginService },
        { type: AppManagementService },
        { type: DataContextService },
        { type: NotificationService }
    ]; };

    var UsersService = /** @class */ (function (_super) {
        __extends(UsersService, _super);
        function UsersService(http, globals) {
            var _this = _super.call(this) || this;
            _this.http = http;
            _this.globals = globals;
            return _this;
        }
        //get the logged in user by using his email address
        UsersService.prototype.GetUserByEmailAddress = function (email) {
            return this.http.get(this.globals.apiURL + "api/Users/GetUserByEmailAddress", {
                params: {
                    email: email
                }
            })
                .pipe(operators.catchError(this.handleError));
        };
        return UsersService;
    }(BaseService));
    UsersService.decorators = [
        { type: core.Injectable }
    ];
    UsersService.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: qmuzikAngularModelCore.AppGlobal }
    ]; };

    //this service is a utility service
    //add any generic logic that can help speed up development
    var UtilityService = /** @class */ (function (_super) {
        __extends(UtilityService, _super);
        function UtilityService() {
            var _this = _super.call(this) || this;
            _this.reloadRulesSubscription = new rxjs.Subject();
            _this.reloadPropertySettingsSubscription = new rxjs.Subject();
            _this.headerChangedSubscription = new rxjs.Subject();
            //subscription: maintain a list of all open component bases
            //they have to subscribe to each other's publish events in order to communicate
            //public openComponents: ComponentBase[] = []
            _this.openComponents = [];
            return _this;
        }
        //paging: return the requested page in an array of objects
        UtilityService.prototype.getPage = function (originalArray, pageQuantity, pageNumber) {
            var pagedArray;
            pageNumber = pageNumber - 1;
            pagedArray = originalArray.slice((pageNumber * pageQuantity), (pageNumber * pageQuantity) + pageQuantity);
            return pagedArray;
        };
        return UtilityService;
    }(BaseService));
    UtilityService.decorators = [
        { type: core.Injectable }
    ];
    UtilityService.ctorParameters = function () { return []; };

    var AuthGuardService = /** @class */ (function () {
        function AuthGuardService(loginService, router) {
            this.loginService = loginService;
            this.router = router;
        }
        AuthGuardService.prototype.canActivate = function (route, state) {
            //if not logged in, must be routed to the login page
            if (this.loginService.isLoggedIn) {
                return true;
            }
            else {
                this.router.navigate(['/']);
            }
            return false;
        };
        return AuthGuardService;
    }());
    AuthGuardService.decorators = [
        { type: core.Injectable }
    ];
    AuthGuardService.ctorParameters = function () { return [
        { type: LoginService },
        { type: router.Router }
    ]; };

    //note: any instance related services to be hosted here
    //      generic things required for processes
    var InstanceService = /** @class */ (function (_super) {
        __extends(InstanceService, _super);
        function InstanceService(http, loginService, router, initialisationService) {
            var _this = _super.call(this) || this;
            _this.http = http;
            _this.loginService = loginService;
            _this.router = router;
            _this.initialisationService = initialisationService;
            _this.activitiesSubscription = new rxjs.Subject();
            _this.variableInputOutputSubscription = new rxjs.Subject();
            _this.symbolInstanceSubscription = new rxjs.Subject();
            _this.instanceVariableSubscription = new rxjs.Subject();
            _this.updateTaskListSubject = new rxjs.Subject();
            return _this;
        }
        InstanceService.prototype.ngOnDestroy = function () {
        };
        /**
         * Return all activities for a symbol instance
         * @param symbolInstanceId
         */
        InstanceService.prototype.GetActivitiesForInstance = function (symbolInstanceId) {
            var _this = this;
            var observables = [];
            if (this.loginService.selectedDataContext.CompanyID === "") {
                return;
            }
            var headers = new http.HttpHeaders({
                "CompanyID": this.loginService.selectedDataContext.CompanyID,
                "InstanceInformation": ['0', symbolInstanceId.toString(), '0', '', 'false', '0']
            });
            var observable = this.http.get(this.loginService.selectedDataContext.ServiceUri + "api/InstanceUtility/GetActivitiesForInstance", {
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
            observable.subscribe(function (result) {
                _this.activitiesSubscription.next({ "activities": result, "symbolInstanceId": symbolInstanceId });
            });
        };
        /**
         * Create a new instance and open if found
         * @param symbolInstanceId
         */
        InstanceService.prototype.GetNewInstance = function (templateDefaultAssociationId) {
            var _this = this;
            var observables = [];
            if (this.loginService.selectedDataContext.CompanyID === "") {
                return;
            }
            var headers = new http.HttpHeaders({
                "CompanyID": this.loginService.selectedDataContext.CompanyID,
                "InstanceInformation": ['0', '0', '0', '', 'false', '0']
            });
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('templateDefaultAssociationId', templateDefaultAssociationId);
            var observable = this.http.get(this.loginService.selectedDataContext.ServiceUri + "api/InstanceUtility/GetNewInstance", {
                headers: headers,
                params: httpParams
            })
                .pipe(operators.catchError(this.handleError));
            observable.subscribe(function (result) {
                _this.Navigate(result.ViewName, result.InstanceId, result.SymbolInstanceId, result.InstanceMode);
            });
        };
        /**
         * Check if a qt instance should be opened on login/context switch
         */
        InstanceService.prototype.GetOpenOnStartup = function () {
            var _this = this;
            var observables = [];
            if (this.loginService.selectedDataContext.CompanyID === "") {
                return;
            }
            var headers = new http.HttpHeaders({
                "CompanyID": this.loginService.selectedDataContext.CompanyID,
                "InstanceInformation": ['0', '0', '0', '', 'false', '0']
            });
            var observable = this.http.get(this.loginService.selectedDataContext.ServiceUri + "api/InstanceUtility/GetOpenOnStartup", {
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
            observable.subscribe(function (result) {
                if (result !== null) {
                    _this.Navigate(result.ViewName, result.InstanceId, result.SymbolInstanceId, result.InstanceMode);
                }
            });
        };
        /**
         * Retrieve the symbol instance object we are working with
         * @param symbolInstanceId
         */
        InstanceService.prototype.GetSymbolInstance = function (symbolInstanceId) {
            var _this = this;
            var observables = [];
            if (this.loginService.selectedDataContext.CompanyID === "") {
                return;
            }
            var headers = new http.HttpHeaders({
                "CompanyID": this.loginService.selectedDataContext.CompanyID,
                "InstanceInformation": ['0', symbolInstanceId.toString(), '0', '', 'false', '0']
            });
            var observable = this.http.get(this.loginService.selectedDataContext.ServiceUri + "api/InstanceUtility/GetSymbolInstance", {
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
            observable.subscribe(function (result) {
                _this.symbolInstanceSubscription.next(result);
            });
        };
        /**
         * Return all input output definitions for a symbol instance
         *
         * @param symbolInstanceId
         */
        InstanceService.prototype.GetVariableInputOutputForSymbolInstance = function (symbolInstanceId) {
            var _this = this;
            var observables = [];
            if (this.loginService.selectedDataContext.CompanyID === "") {
                return;
            }
            var headers = new http.HttpHeaders({
                "CompanyID": this.loginService.selectedDataContext.CompanyID,
                "InstanceInformation": ['0', symbolInstanceId.toString(), '0', '', 'false', '0']
            });
            var observable = this.http.get(this.loginService.selectedDataContext.ServiceUri + "api/InstanceUtility/GetVariableInputOutputForSymbolInstance", {
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
            observable.subscribe(function (result) {
                _this.variableInputOutputSubscription.next({ "variableInputOutput": result, "symbolInstanceId": symbolInstanceId });
            });
        };
        /**
         * Return all the instance variables
         *
         * @param instanceId
         */
        InstanceService.prototype.GetVariablesForInstance = function (instanceId) {
            var _this = this;
            var observables = [];
            if (this.loginService.selectedDataContext.CompanyID === "") {
                return;
            }
            var headers = new http.HttpHeaders({
                "CompanyID": this.loginService.selectedDataContext.CompanyID,
                "InstanceInformation": [instanceId.toString(), '0', '0', '', 'false', '0']
            });
            var observable = this.http.get(this.loginService.selectedDataContext.ServiceUri + "api/InstanceUtility/GetVariablesForInstance", {
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
            observable.subscribe(function (result) {
                _this.instanceVariableSubscription.next(result);
            });
        };
        /**
         * Route to the correct view based upon the view name
         *
         * @param viewName
         * @param instanceId
         * @param symbolInstanceId
         * @param instanceMode
         */
        InstanceService.prototype.Navigate = function (viewName, instanceId, symbolInstanceId, instanceMode) {
            var _this = this;
            //note: first identify the route based upon the view internal name 
            var view = null;
            for (var i = 0; i < Object.keys(this.initialisationService.companyViews[this.loginService.selectedDataContext.CompanyID]).length; i++) {
                var checkView = (this.initialisationService.companyViews[this.loginService.selectedDataContext.CompanyID][Object.keys(this.initialisationService.companyViews[this.loginService.selectedDataContext.CompanyID])[i]]);
                //note we have found the match
                if (checkView.InternalName === viewName) {
                    view = checkView;
                    break;
                }
            }
            if (view !== null) {
                this.router.navigate(['/blank']).then(function () { return _this.router.navigate([view.Route], {
                    state: {
                        viewFriendlyName: view.Name,
                        internalName: view.InternalName,
                        InstanceId: instanceId,
                        SymbolInstanceId: symbolInstanceId,
                        InstanceMode: instanceMode
                    }
                }); });
            }
        };
        /**
         * Handle all instance actions when a component does not inherit from componentbase
         *
         * @param modelState
         * @param isNew
         * @param instanceInformation
         */
        InstanceService.prototype.DoInstanceActions = function (modelState, isNew, instanceInformation) {
            return new rxjs.Observable(null);
        };
        /**
          * Delete/Cancel an instance
          *
          * Effectively, this means setting Active=0
          *
          * Template Type will dicate if all instance history is destroyed.
          *
          * @param instanceId
          * @param symbolInstanceId
          */
        InstanceService.prototype.DeleteInstance = function (instanceId, symbolInstanceId) {
            var _this = this;
            var observables = [];
            if (this.loginService.selectedDataContext.CompanyID === "") {
                return;
            }
            var headers = new http.HttpHeaders({
                "CompanyID": this.loginService.selectedDataContext.CompanyID,
                "InstanceInformation": [instanceId.toString(), '0', '0', '', 'false', '0']
            });
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('instanceId', instanceId.toString());
            var observable = this.http.delete(this.loginService.selectedDataContext.ServiceUri + "api/InstanceUtility/DeleteInstance", {
                headers: headers,
                params: httpParams
            })
                .pipe(operators.catchError(this.handleError));
            observable.subscribe(function () {
                _this.updateTaskListSubject.next({
                    "Action": "Remove",
                    "InputTask": null,
                    "SymbolInstanceId": symbolInstanceId
                });
            });
        };
        return InstanceService;
    }(BaseService));
    InstanceService.decorators = [
        { type: core.Injectable }
    ];
    InstanceService.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: LoginService },
        { type: router.Router },
        { type: InitialisationService }
    ]; };

    var DynamicViewService = /** @class */ (function (_super) {
        __extends(DynamicViewService, _super);
        function DynamicViewService(initialisationService, componentFactoryResolver, injector, compiler) {
            var _this = _super.call(this) || this;
            _this.initialisationService = initialisationService;
            _this.componentFactoryResolver = componentFactoryResolver;
            _this.injector = injector;
            _this.compiler = compiler;
            _this.dynamicComponentRegistry = [];
            return _this;
        }
        DynamicViewService.prototype.GetDynamicComponent = function (internalName) {
            return __awaiter(this, void 0, void 0, function () {
                var registryItem;
                var _this = this;
                return __generator(this, function (_a) {
                    registryItem = this.getRegistryItemForView(internalName);
                    if (registryItem == null) {
                        return [2 /*return*/, this.getDynamicContentErrorComponent("Unable to find a registry item for view: " + internalName + ".")];
                    }
                    return [2 /*return*/, registryItem.platform.loadChildren().then(function (moduleOrFactory) {
                            try {
                                if (moduleOrFactory instanceof core.NgModuleFactory) {
                                    return moduleOrFactory;
                                }
                                else {
                                    return _this.compiler.compileModuleAsync(moduleOrFactory);
                                }
                            }
                            catch (error) {
                                return _this.getDynamicContentErrorComponent("Unable to load module " + registryItem.modulePath + ".\n                      Looked up using component: " + registryItem.componentName + ". Error Details: " + error.message);
                            }
                        }).then(function (moduleFactory) {
                            try {
                                var moduleReference = moduleFactory.create(_this.injector);
                                var componentResolver = moduleReference.componentFactoryResolver;
                                var componentType = moduleFactory.moduleType.dynamicComponentsMap[registryItem.componentName];
                                var componentFactory = componentResolver.resolveComponentFactory(componentType);
                                return componentFactory.create(_this.injector);
                            }
                            catch (error) {
                                return _this.getDynamicContentErrorComponent("Unable to load module " + registryItem.modulePath + ".\n                      Looked up using component: " + registryItem.componentName + ". Error Details: " + error.message);
                            }
                        })];
                });
            });
        };
        DynamicViewService.prototype.GetModulePathFromRegistryItem = function (registryItem) {
            if (registryItem && registryItem.modulePath) {
                return registryItem.modulePath + "#" + registryItem.moduleName;
            }
            return null;
        };
        DynamicViewService.prototype.getRegistryItemForView = function (internalName) {
            var registryItem = this.dynamicComponentRegistry.find(function (i) { return i.internalName === internalName; });
            if (registryItem != null) {
                return registryItem;
            }
            return null;
        };
        DynamicViewService.prototype.getDynamicContentErrorComponent = function (errorMessage) {
            var factory = this.componentFactoryResolver.resolveComponentFactory(qmuzikAngularModelCore.DynamicContentErrorComponent);
            var componentRef = factory.create(this.injector);
            var instance = componentRef.instance;
            instance.errorMessage = errorMessage;
            return componentRef;
        };
        //simulates the resolver's work when using routes to access functions
        DynamicViewService.prototype.simulateResolver = function (view) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.initialisationService.cachedViewRules[view.InternalName] ===
                                undefined)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.initialisationService
                                    .GetRules(view.InternalName)
                                    .toPromise()
                                    .then(function (result) {
                                    _this.initialisationService.InitialiseCompanyRules(result, view.InternalName);
                                })];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2:
                            if (!(this.initialisationService.cachedViewNotifications[view.InternalName] ===
                                undefined)) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.initialisationService
                                    .GetNotificationMessages(view.InternalName)
                                    .toPromise()
                                    .then(function (result) {
                                    _this.initialisationService.InitialiseCompanyNotifications(result, view.InternalName);
                                })];
                        case 3:
                            _a.sent();
                            _a.label = 4;
                        case 4:
                            if (!(this.initialisationService.cachedViewProperties[view.InternalName] ===
                                undefined)) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.initialisationService
                                    .GetPropertyConfiguration(view.InternalName)
                                    .toPromise()
                                    .then(function (result) {
                                    _this.initialisationService.cachedViewProperties[view.InternalName] = result;
                                })];
                        case 5:
                            _a.sent();
                            _a.label = 6;
                        case 6: return [2 /*return*/, true];
                    }
                });
            });
        };
        return DynamicViewService;
    }(BaseService));
    DynamicViewService.decorators = [
        { type: core.Injectable }
    ];
    DynamicViewService.ctorParameters = function () { return [
        { type: InitialisationService },
        { type: core.ComponentFactoryResolver },
        { type: core.Injector },
        { type: core.Compiler }
    ]; };

    /**
     * Services for the component options component
     */
    var ComponentOptionsService = /** @class */ (function (_super) {
        __extends(ComponentOptionsService, _super);
        function ComponentOptionsService(dynamicViewService, loginService, initialisationService, changeDetectorRef) {
            var _this = _super.call(this) || this;
            _this.dynamicViewService = dynamicViewService;
            _this.loginService = loginService;
            _this.initialisationService = initialisationService;
            _this.changeDetectorRef = changeDetectorRef;
            _this.modelstateProperties = [];
            _this.numericModelStateProperties = [];
            _this.sortProperties = [];
            _this.aggregateProperties = [];
            _this.aggregates = [];
            _this.aggregateMap = new Map();
            _this.labels = new Map();
            _this.modelStatePropertyLabels = new Map();
            _this.modelStatePropertyLabelsLoading = false;
            _this.employeeDefaults = [];
            _this.changesAppliedtoAllChildren = false;
            _this.saveToDefaultTrigger = new rxjs.Subject();
            _this.deleteDefaultTrigger = new rxjs.Subject();
            _this.sortListTrigger = new rxjs.Subject();
            _this.calcAggregateTrigger = new rxjs.Subject();
            _this.exportToExcelTrigger = new rxjs.Subject();
            _this.undoLastChangeTrigger = new rxjs.Subject();
            _this.undoAllChangesTrigger = new rxjs.Subject();
            _this.applyChangesToAllChildren = new rxjs.Subject();
            _this.serialisationLevelChanged = new rxjs.Subject();
            _this.labelsLoaded = new rxjs.Subject();
            _this.closeOptionsTrigger = new rxjs.Subject();
            _this.pinOptionsTrigger = new rxjs.Subject();
            _this.serializationLevel = 0;
            _this.views = [];
            _this.modelStatePropertyLabelsLoaded = false;
            _this.setDefaultLabels();
            _this.loadViews();
            return _this;
        }
        /**
         * Cleanup
         */
        ComponentOptionsService.prototype.ngOnDestroy = function () {
            if (this.initialisationServiceSubscription) {
                this.initialisationServiceSubscription.unsubscribe();
            }
        };
        ComponentOptionsService.prototype.setSerialisationLevel = function (level) {
            this.serializationLevel = level;
            this.serialisationLevelChanged.next(this.serializationLevel);
        };
        /**
         * Extract stuff from component base
         *
         * @param properties
         */
        ComponentOptionsService.prototype.loadModelStateProperties = function (properties) {
            var _a;
            (_a = this.modelstateProperties).push.apply(_a, __spread(properties));
        };
        ComponentOptionsService.prototype.loadNumericModelStateProperties = function (numericProperties) {
            var _a;
            (_a = this.numericModelStateProperties).push.apply(_a, __spread(numericProperties));
        };
        /**
         * Sort
         */
        ComponentOptionsService.prototype.sortModelStateList = function () {
            this.sortListTrigger.next(this.sortProperties);
        };
        /**
         * Aggregate mechanism
         *
         * @param propertyAction
         */
        ComponentOptionsService.prototype.calculateAggregate = function (propertyAction) {
            this.calcAggregateTrigger.next(propertyAction);
        };
        /**
         * Save to defaults
         *
         * @param defaultName
         */
        ComponentOptionsService.prototype.saveToDefaults = function (defaultName) {
            this.saveToDefaultTrigger.next(defaultName);
        };
        ComponentOptionsService.prototype.deleteDefault = function (defaultInstance) {
            this.deleteDefaultTrigger.next(defaultInstance);
        };
        ComponentOptionsService.prototype.setApplyToAll = function (value) {
            this.changesAppliedtoAllChildren = value;
            this.applyChangesToAllChildren.next(value);
        };
        ComponentOptionsService.prototype.getComponentOptionLabel = function (key) {
            return this.labels.get(key);
        };
        ComponentOptionsService.prototype.setLabels = function (labels) {
            this.labels = labels;
            this.populateAggregates();
            this.labelsLoaded.next();
        };
        ComponentOptionsService.prototype.exportToExcel = function () {
            this.exportToExcelTrigger.next();
        };
        ComponentOptionsService.prototype.undoLastChange = function () {
            this.undoLastChangeTrigger.next();
        };
        ComponentOptionsService.prototype.undoAllChanges = function () {
            this.undoAllChangesTrigger.next();
        };
        ComponentOptionsService.prototype.setDefaultLabels = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.labels.set("AggregateCount", "Count");
                    this.labels.set("AggregateMin", "Minimum");
                    this.labels.set("AggregateMax", "Maximum");
                    this.labels.set("AggregateAvg", "Average");
                    this.labels.set("AggregateSum", "Total");
                    this.labels.set("ApplyToAll", "Apply changes to all");
                    this.labels.set("ListOptions", "List Options");
                    this.labels.set("Options", "Options");
                    this.labels.set("SortList", "Sort List");
                    this.labels.set("SortBy", "Sort by:");
                    this.labels.set("CalcAggregate", "Calculate Aggregate(s)");
                    this.labels.set("CalcAggregateFor", "Calculate Aggregate(s) for");
                    this.labels.set("ChooseAggregate", "Choose...");
                    this.labels.set("AggregateContext", "Context");
                    this.labels.set("AggregateContextDisplayOnly", "Displayed");
                    this.labels.set("AggregateContextAll", "All");
                    this.labels.set("AggregateContextSelectedList", "Selected");
                    this.labels.set("AggregateTHProperty", "Property");
                    this.labels.set("AggregateTHAggregate", "Aggregate");
                    this.labels.set("AggregateTHResult", "Result");
                    this.labels.set("ManageDefaults", "Manage my defaults");
                    this.labels.set("DefaultName", "Default Name:");
                    this.labels.set("ExistingDefaults", "Existing default(s)");
                    this.labels.set("SerializationLevel", "Serialization Level");
                    this.labels.set("ExportToExcel", "Export To Excel");
                    this.labels.set("Undo", "Undo");
                    this.populateAggregates();
                    this.labelsLoaded.next();
                    return [2 /*return*/];
                });
            });
        };
        ComponentOptionsService.prototype.populateAggregates = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.aggregates = [];
                    this.aggregates.push(this.labels.get("AggregateCount"));
                    this.aggregates.push(this.labels.get("AggregateMin"));
                    this.aggregates.push(this.labels.get("AggregateMax"));
                    this.aggregates.push(this.labels.get("AggregateAvg"));
                    this.aggregates.push(this.labels.get("AggregateSum"));
                    this.aggregateMap.set(this.labels.get("AggregateCount"), "COUNT");
                    this.aggregateMap.set(this.labels.get("AggregateMin"), "MIN");
                    this.aggregateMap.set(this.labels.get("AggregateMax"), "MAX");
                    this.aggregateMap.set(this.labels.get("AggregateAvg"), "AVG");
                    this.aggregateMap.set(this.labels.get("AggregateSum"), "SUM");
                    return [2 /*return*/];
                });
            });
        };
        ComponentOptionsService.prototype.getComponent = function (viewName) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.dynamicViewService.GetDynamicComponent(viewName)];
                });
            });
        };
        ComponentOptionsService.prototype.ViewExists = function (name) {
            for (var i = 0; i < this.views.length; i++) {
                if (this.views[i].Name === name) {
                    //found
                    return true;
                }
            }
            //not found
            return false;
        };
        ComponentOptionsService.prototype.GetView = function (internalName) {
            for (var i = 0; i < this.views.length; i++) {
                if (this.views[i].InternalName === internalName) {
                    //found
                    return this.views[i];
                }
            }
            //not found
            return null;
        };
        ComponentOptionsService.prototype.loadViews = function () {
            var _this = this;
            var view;
            var views = new qmuzikAngularModelCore.Views();
            //note: 1st check if view have been retrieved
            //this must change, once we have decided how to handle views for different companies
            if (Object.keys(this.initialisationService.companyViews).length > 0) {
                //note: run through views returned from all companies
                for (var i = 0; i < Object.keys(this.initialisationService.companyViews).length; i++) {
                    var views_1 = this.initialisationService.companyViews[Object.keys(this.initialisationService.companyViews)[i]];
                    for (var j = 0; j < Object.keys(views_1).length; j++) {
                        var view_1 = views_1[Object.keys(views_1)[j]];
                        if (!this.ViewExists(view_1.Name)) {
                            this.views.push(view_1);
                        }
                    }
                }
            }
            else {
                //note: set up the views for each company
                for (var i = 0; i < this.loginService.dataContext.length; i++) {
                    if (this.loginService.dataContext[i].CompanyID === "") {
                        continue;
                    }
                    if (this.initialisationService.companyViews[this.loginService.dataContext[i].CompanyID] === undefined) {
                        this.initialisationService.companyViews[this.loginService.dataContext[i].CompanyID] = new qmuzikAngularModelCore.Views();
                    }
                }
                this.initialisationServiceSubscription = this.initialisationService
                    .GetMyViews()
                    .subscribe(function (result) {
                    //loop and create the view for each company
                    for (var i = 0; i < result.length; i++) {
                        view = new qmuzikAngularModelCore.View();
                        view.InternalName = result[i].InternalName;
                        view.Name = result[i].Name;
                        view.EntityName = result[i].EntityName;
                        view.Route = result[i].Route;
                        view.IsMenuItem = result[i].IsMenuItem;
                        _this.initialisationService.companyViews[result[i].Company_ID][view.InternalName] = view;
                    }
                    //note: run through views returned from all companies
                    for (var i = 0; i < Object.keys(_this.initialisationService.companyViews).length; i++) {
                        var views_2 = _this.initialisationService.companyViews[Object.keys(_this.initialisationService.companyViews)[i]];
                        for (var j = 0; j < Object.keys(views_2).length; j++) {
                            var view_2 = views_2[Object.keys(views_2)[j]];
                            if (!_this.ViewExists(view_2.Name) && view_2.IsMenuItem) {
                                _this.views.push(view_2);
                            }
                        }
                    }
                    //note: when jumping from one component to next, we will use the activated views
                    //to decide which view to open (together with the Entity property)
                    _this.initialisationService.activatedViews = _this.views;
                    //this.viewsRetrievedSubscription.next(null);
                });
            }
        };
        ComponentOptionsService.prototype.formatString = function (input) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            args.forEach(function (arg, i) {
                input = input.replace(new RegExp('\\{' + i + '\\}'), arg);
            });
            return input;
        };
        ComponentOptionsService.prototype.simulateResolver = function (view) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this.initialisationService.cachedViewRules[view.InternalName] ===
                                undefined)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.initialisationService
                                    .GetRules(view.InternalName)
                                    .toPromise()
                                    .then(function (result) {
                                    _this.initialisationService.InitialiseCompanyRules(result, view.InternalName);
                                })];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2:
                            if (!(this.initialisationService.cachedViewNotifications[view.InternalName] ===
                                undefined)) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.initialisationService
                                    .GetNotificationMessages(view.InternalName)
                                    .toPromise()
                                    .then(function (result) {
                                    _this.initialisationService.InitialiseCompanyNotifications(result, view.InternalName);
                                })];
                        case 3:
                            _a.sent();
                            _a.label = 4;
                        case 4:
                            if (!(this.initialisationService.cachedViewProperties[view.InternalName] ===
                                undefined)) return [3 /*break*/, 6];
                            return [4 /*yield*/, this.initialisationService
                                    .GetPropertyConfiguration(view.InternalName)
                                    .toPromise()
                                    .then(function (result) {
                                    _this.initialisationService.cachedViewProperties[view.InternalName] = result;
                                })];
                        case 5:
                            _a.sent();
                            _a.label = 6;
                        case 6: return [2 /*return*/, true];
                    }
                });
            });
        };
        ComponentOptionsService.prototype.CloseOptions = function () {
            this.closeOptionsTrigger.next();
        };
        ComponentOptionsService.prototype.ToggleOptionsPin = function () {
            this.pinOptionsTrigger.next();
        };
        return ComponentOptionsService;
    }(BaseService));
    ComponentOptionsService.decorators = [
        { type: core.Injectable }
    ];
    ComponentOptionsService.ctorParameters = function () { return [
        { type: DynamicViewService },
        { type: LoginService },
        { type: InitialisationService },
        { type: core.ChangeDetectorRef }
    ]; };

    var ColumnValuesService = /** @class */ (function (_super) {
        __extends(ColumnValuesService, _super);
        //private languageCodeService: LanguageCodeService;
        function ColumnValuesService(http, loginService, dataContextService) {
            var _this = _super.call(this) || this;
            _this.http = http;
            _this.loginService = loginService;
            _this.dataContextService = dataContextService;
            _this.defaultColumnValues = [];
            _this.servicesInjected = false;
            //#endregion
            //#region header control search 
            _this.formatter = function (result) { return (_this.GetFormatter(result)); };
            _this.inputFormatter = function (result) { return (result.ColumnName + " " + result.ColumnValue); };
            //retrieve defaults used for creation of new model instance
            _this.GetDefaults();
            return _this;
        }
        //#region injection
        ColumnValuesService.prototype.InjectServices = function () {
            //this.languageCodeService = AppInjector.get(LanguageCodeService);
            this.servicesInjected = true;
        };
        //#endregion injection
        //this is how we will retrieve column values
        ColumnValuesService.prototype.GetColumnValuesByColumnName = function (columnName) {
            var uri;
            //here we know the CompanyID
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === "") {
                    continue;
                }
                //column values will always be the same accross databases?? Different hotfixes??
                //use the first company found for now
                uri = this.loginService.dataContext[i].ServiceUri + "api/Column_ValuesLibrary/GetColumn_ValuesByColumnName";
                break;
            }
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append('columnName', columnName);
            var headers = new http.HttpHeaders({
                "CompanyID": this.loginService.dataContext[i].CompanyID
            });
            return this.http.get(uri, {
                params: httpParams,
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
        };
        //#region crud
        //generated: create a new instance of the model
        ColumnValuesService.prototype.CreateNew = function () {
            //note: default values must be obtained for each company from the rest api
            var source;
            var target = new qmuzikAngularModelCore.ColumnValues();
            for (var i = 0; i < this.defaultColumnValues.length; i++) {
                if (this.defaultColumnValues[i].CompanyID == this.loginService.defaultCompanyID) {
                    source = this.defaultColumnValues[i];
                    break;
                }
            }
            Object.assign(target, source);
            return target;
        };
        //generated: call to rest api to delete a model instance
        ColumnValuesService.prototype.Delete = function (modelState) {
            var uri;
            //here we know the CompanyID
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID == modelState.CompanyID) {
                    uri = this.loginService.dataContext[i].ServiceUri + "api/Column_ValuesLibrary";
                    break;
                }
            }
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append("ColumnName", modelState.ColumnName);
            httpParams = httpParams.append("ColumnValue", modelState.ColumnValue);
            var headers = new http.HttpHeaders({
                "CompanyID": modelState.CompanyID
            });
            return this.http.delete(uri, {
                params: httpParams,
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
        };
        //generated: call to rest api to save a new model instance, or update and existing model instance
        ColumnValuesService.prototype.Save = function (modelState, isNew) {
            var uri;
            modelState["PropertyStoreType"] = null;
            //here we know the CompanyID
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID == modelState.CompanyID) {
                    uri = this.loginService.dataContext[i].ServiceUri + "api/Column_ValuesLibrary";
                    break;
                }
            }
            var headers = new http.HttpHeaders({
                "CompanyID": modelState.CompanyID
            });
            if (isNew) {
                return this.http.post(this.loginService.dataContext[i].ServiceUri + "api/Column_ValuesLibrary/PostColumn_Values", modelState, {
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
            }
            else {
                var httpParams = new http.HttpParams();
                httpParams = httpParams.append("ColumnName", modelState.ColumnName);
                httpParams = httpParams.append("ColumnValue", modelState.ColumnValue);
                return this.http.put(this.loginService.dataContext[i].ServiceUri + "api/Column_ValuesLibrary", modelState, {
                    params: httpParams,
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
            }
        };
        //#endregion
        ColumnValuesService.prototype.SaveInstance = function (modelState, isNew, instanceId, symbolInstanceId, symbolInstanceActivityId, chosenSymbolInstanceActivityId, instanceAction) {
            return new rxjs.Observable(null);
        };
        //#region create for
        //generated: we need an instance to build our form initially
        ColumnValuesService.prototype.CreateForInitialisation = function () {
            var columnValues = new qmuzikAngularModelCore.ColumnValues();
            columnValues.CompanyID = this.loginService.defaultCompanyID;
            return columnValues;
        };
        //generated: initialise all properties of model instance to null
        ColumnValuesService.prototype.CreateForFilter = function () {
            var columnValues = new qmuzikAngularModelCore.ColumnValues();
            Object.keys(columnValues).forEach(function (key) {
                columnValues[key] = null;
            });
            columnValues.CompanyID = this.loginService.defaultCompanyID;
            return columnValues;
        };
        //#endregion
        //#region assign to type
        //generated: selecting an object in the typeahead we need to "cast" it to the required type so that instanceof works
        ColumnValuesService.prototype.AssignToType = function (item) {
            //this is just for testing
            //once we generated classes for company tables 
            //we won't have to select it here
            //item.CompanyID = this.loginService.defaultCompanyID;
            //must use assign here, otherwise instancof checks will not work
            return Object.assign(new qmuzikAngularModelCore.ColumnValues(), item);
        };
        //generated: assign all foreign key properties to it's actual type so that instanceof works
        ColumnValuesService.prototype.AssignToTypeForeignKey = function (item, foreignKeyProperty) {
            if (!this.servicesInjected) {
                this.InjectServices();
            }
            // if(foreignKeyProperty == 'RefLanguageCode'){
            //   //must use assign here, otherwise instancof checks will not work
            //   return this.languageCodeService.AssignToType(item);
            // }
            if (foreignKeyProperty == 'Ref_CompanyID') {
                //must use assign here, otherwise instancof checks will not work
                return this.dataContextService.AssignToType(item);
            }
        };
        //note: if multi-company we must display the id so a user can "know"
        ColumnValuesService.prototype.GetFormatter = function (result) {
            if (this.loginService.defaultCompanyID === "") {
                for (var i = 0; i < this.loginService.dataContext.length; i++) {
                    if (result.CompanyID === this.loginService.dataContext[i].CompanyID) {
                        return result.ColumnName + " | " + result.ColumnValue + "   |   " + this.loginService.dataContext[i].CompanyName;
                    }
                }
            }
            else {
                return result.ColumnName + " | " + result.ColumnValue;
            }
        };
        //#endregion
        //generated: for all companies, retrieve the default values for a new model instance
        ColumnValuesService.prototype.GetDefaults = function () {
            var _this = this;
            //run through data contexts and get the defaults for a company
            var observables = [];
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === "") {
                    continue;
                }
                var headers = new http.HttpHeaders({
                    "CompanyID": this.loginService.dataContext[i].CompanyID
                });
                var observable = this.http.get(this.loginService.dataContext[i].ServiceUri + "api/Column_ValuesLibrary/GetColumn_ValuesDefault", {
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
                observables.push(observable);
            }
            ;
            rxjs.forkJoin(observables).pipe(operators.map(function (data) {
                return _this.FormatObserveablesArray(data);
            })).subscribe(function (result) {
                _this.defaultColumnValues = result;
            });
        };
        //generated: return a single object by primary key
        ColumnValuesService.prototype.GetByPrimaryKey = function (ColumnName, ColumnValue, CompanyID) {
            var uri;
            //here we know the CompanyID
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID == CompanyID) {
                    uri = this.loginService.dataContext[i].ServiceUri + "api/Column_ValuesLibrary";
                    break;
                }
            }
            var httpParams = new http.HttpParams();
            httpParams = httpParams.append("ColumnName", ColumnName);
            httpParams = httpParams.append("ColumnValue", ColumnValue);
            var headers = new http.HttpHeaders({
                "CompanyID": CompanyID
            });
            return this.http.get(uri, {
                params: httpParams,
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
        };
        ColumnValuesService.prototype.Search = function (filter, advancedFilter) {
            var _this = this;
            //get the operator array
            //always use "like" for the standard filter
            var operatorArray;
            //so, remember why we do it this way:
            //we need to send the model state to the rest service
            //reason: depending on the model state it may filter itself differently
            //that is not something I can "generate", it depends on business rules
            var searchCriteria = {};
            searchCriteria.filter = filter;
            //add any advanced filters to the array
            if ((advancedFilter !== undefined) && (advancedFilter !== null)) {
                if (advancedFilter.length != 0) {
                    searchCriteria.filter = [];
                }
                for (var j = 0; j < advancedFilter.length; j++) {
                    advancedFilter[j]["HeaderControl"] = null;
                    advancedFilter[j]["Ref_CompanyID"] = null;
                    searchCriteria.filter.push(advancedFilter[j]);
                }
                operatorArray = this.GetOperatorArray(null, advancedFilter);
            }
            else {
                operatorArray = this.GetOperatorArray(filter, null);
            }
            searchCriteria.operators = operatorArray;
            var observables = [];
            if (this.loginService.defaultCompanyID === "") {
                for (var i = 0; i < this.loginService.dataContext.length; i++) {
                    if (this.loginService.dataContext[i].CompanyID === "") {
                        continue;
                    }
                    var headers = new http.HttpHeaders({
                        "CompanyID": this.loginService.dataContext[i].CompanyID
                    });
                    var observable = this.http.post(this.loginService.dataContext[i].ServiceUri + "api/Column_ValuesLibrary/PostColumnValues_HeaderControl", searchCriteria, {
                        headers: headers
                    })
                        .pipe(operators.catchError(this.handleError));
                    observables.push(observable);
                }
            }
            else {
                //note: if a "company" is selected globally only search there
                var headers = new http.HttpHeaders({
                    "CompanyID": this.loginService.selectedDataContext.CompanyID
                });
                var observable = this.http.post(this.loginService.selectedDataContext.ServiceUri + "api/Column_ValuesLibrary/PostColumnValues_HeaderControl", searchCriteria, {
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
                observables.push(observable);
            }
            return rxjs.forkJoin(observables).pipe(operators.map(function (data) {
                return _this.FormatObserveablesArray(data);
            }));
        };
        //return all without filtering
        ColumnValuesService.prototype.GetColumn_Values = function () {
            var _this = this;
            //here is now where the shite his the fan
            //we must merge multiple observables into one result set
            //e.g. loop through all our logged in user's data contexts
            //create an observable for each of those contexts
            //merge the result
            var observables = [];
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === "") {
                    continue;
                }
                var headers = new http.HttpHeaders({
                    "CompanyID": this.loginService.dataContext[i].CompanyID
                });
                var observable = this.http.get(this.loginService.dataContext[i].ServiceUri + "api/Column_ValuesLibrary", {
                    headers: headers
                })
                    .pipe(operators.catchError(this.handleError));
                observables.push(observable);
            }
            return rxjs.forkJoin(observables).pipe(operators.map(function (data) {
                return _this.FormatObserveablesArray(data);
            }));
        };
        //all typeaheads used to find an entity value
        //in the database will generate their own method
        //the object model state will be sent to the api
        //since the data may be required to filter in some
        //custom way
        ColumnValuesService.prototype.Get_ColumnValues_RefLanguageCode = function (filter, advancedFilter, modelState) {
            var _this = this;
            //get the operator array
            //always use "like" for the standard filter
            var operatorArray;
            //so, remember why we do it this way:
            //we need to send the model state to the rest service
            //reason: depending on the model state it may filter itself differently
            //that is not something I can "generate", it depends on business rules
            var searchCriteria = {};
            searchCriteria.filter = filter;
            //add any advanced filters to the array
            if ((advancedFilter !== undefined) && (advancedFilter !== null)) {
                if (advancedFilter.length != 0) {
                    searchCriteria.filter = [];
                }
                for (var j = 0; j < advancedFilter.length; j++) {
                    advancedFilter[j]["HeaderControl"] = null;
                    advancedFilter[j]["Ref_CompanyID"] = null;
                    searchCriteria.filter.push(advancedFilter[j]);
                }
                operatorArray = this.GetOperatorArray(null, advancedFilter);
            }
            else {
                operatorArray = this.GetOperatorArray(filter, null);
            }
            searchCriteria.operators = operatorArray;
            searchCriteria.modelState = {};
            Object.assign(searchCriteria.modelState, modelState);
            searchCriteria.operators = operatorArray;
            //note: if the modelstate has a company id we should only use that
            //only search on all if the company id is null or spaces
            var observables = [];
            searchCriteria.modelState.CompanyID = modelState.CompanyID;
            searchCriteria.modelState.HeaderControl = null;
            var headers = new http.HttpHeaders({
                "CompanyID": modelState.CompanyID
            });
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID === modelState.CompanyID) {
                    break;
                }
            }
            var observable = this.http.post(this.loginService.dataContext[i].ServiceUri + "api/Language_CodeLibrary/PostColumnValues_RefLanguageCode", searchCriteria, {
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
            observables.push(observable);
            return rxjs.forkJoin(observables).pipe(operators.map(function (data) {
                return _this.FormatObserveablesArray(data);
            }));
        };
        //generated: each foreign key must be loadable from here
        ColumnValuesService.prototype.GetForeignKeyObject = function (foreignKey, values, companyID) {
            if (!this.servicesInjected) {
                this.InjectServices();
            }
            // if(foreignKey === "RefLanguageCode"){
            //   //in qmuzik foreign keys are represented by spaces
            //   if((values[0].replace(/ /g, "")) === "" ||  (values[0] === null))
            //   {
            // 	return new Observable(null);
            //   }
            //   return this.languageCodeService.GetByPrimaryKey(values[0], companyID);
            // }  
            if (foreignKey === "Ref_CompanyID") {
                //in qmuzik foreign keys are represented by spaces
                if ((values[0].replace(/ /g, "")) === "" || (values[0] === null)) {
                    return new rxjs.Observable(null);
                }
                for (var i = 0; i < this.loginService.dataContext.length; i++) {
                    if (this.loginService.dataContext[i].CompanyID === values[0]) {
                        return rxjs.of(this.loginService.dataContext[i]);
                    }
                }
            }
        };
        //composite view: a foreign key value has been selected
        //we must now filter on this foreign key
        ColumnValuesService.prototype.FilterByForeignKey = function (filterOnProperties, filterFromProperties, modelState) {
            return new rxjs.Observable(null);
        };
        //generated: call to rest api to validate a property
        ColumnValuesService.prototype.AsyncValidation = function (property, modelState, isNew) {
            var validationCriteria = {};
            validationCriteria.property = property;
            validationCriteria.modelState = modelState;
            validationCriteria.isNew = isNew;
            var uri;
            //here we know the CompanyID
            for (var i = 0; i < this.loginService.dataContext.length; i++) {
                if (this.loginService.dataContext[i].CompanyID == modelState.CompanyID) {
                    uri = this.loginService.dataContext[i].ServiceUri + "api/Column_ValuesLibrary/PostAsyncValidate";
                    break;
                }
            }
            var headers = new http.HttpHeaders({
                "CompanyID": modelState.CompanyID
            });
            return this.http.post(uri, validationCriteria, {
                headers: headers
            })
                .pipe(operators.catchError(this.handleError));
        };
        return ColumnValuesService;
    }(BaseService));
    ColumnValuesService.decorators = [
        { type: core.Injectable }
    ];
    ColumnValuesService.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: LoginService },
        { type: DataContextService }
    ]; };

    //note: service

    var QmuzikAngularServiceModule = /** @class */ (function () {
        function QmuzikAngularServiceModule() {
        }
        return QmuzikAngularServiceModule;
    }());
    QmuzikAngularServiceModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [],
                    declarations: [],
                    providers: [],
                    exports: []
                },] }
    ];

    /*
     * Public API Surface of qmuzik-angular-service
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AppManagementService = AppManagementService;
    exports.AuthGuardService = AuthGuardService;
    exports.BaseService = BaseService;
    exports.ColumnValuesService = ColumnValuesService;
    exports.ComponentOptionsService = ComponentOptionsService;
    exports.DataContextService = DataContextService;
    exports.DynamicViewService = DynamicViewService;
    exports.InitialisationService = InitialisationService;
    exports.InstanceService = InstanceService;
    exports.Interceptor = Interceptor;
    exports.LoginService = LoginService;
    exports.NotificationService = NotificationService;
    exports.QmuzikAngularServiceModule = QmuzikAngularServiceModule;
    exports.UsersService = UsersService;
    exports.UtilityService = UtilityService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=qmuzik-angular-service.umd.js.map
