import { HttpClient } from '@angular/common/http';
import { AppGlobal } from 'qmuzik-angular-model-core';
import { BaseService } from './base.service';
import { DataContext } from 'qmuzik-angular-model-core';
import { LoginService } from './login.service';
/**
 * Services for anyone required to work with data contexts
 */
export declare class DataContextService extends BaseService {
    private http;
    private appGlobal;
    private loginService;
    username: string;
    constructor(http: HttpClient, appGlobal: AppGlobal, loginService: LoginService);
    GetDataContext(username: string): import("rxjs").Observable<DataContext[]>;
    GetDataContextById(id: string): import("rxjs").Observable<DataContext>;
    GetRetrievedDataContexts(): import("rxjs").Observable<DataContext[]>;
    AssignToType(item: any): DataContext;
    GetDataContextForCompanyId(companyID: string): DataContext;
}
