import { BaseService } from './base.service';
import { NotificationVariable } from 'qmuzik-angular-model-core';
import { NotificationMessage } from 'qmuzik-angular-model-core';
import { InitialisationService } from './initialisation.service';
export declare class NotificationService extends BaseService {
    initialisationService: InitialisationService;
    notificationMessages: {};
    constructor(initialisationService: InitialisationService);
    GetNotification(notificationId: number, notificationVariables: NotificationVariable, companyID: string, name: string): NotificationMessage;
    ReplaceVariables(errorMessage: string, notificationVariables: NotificationVariable, keys: string[]): string;
    GetNotifications(viewName: string): void;
}
