import { Injector, Compiler, ComponentFactoryResolver } from "@angular/core";
import { InitialisationService } from "./initialisation.service";
import { View, RegistryItem } from "qmuzik-angular-model-core";
import { BaseService } from "./base.service";
export declare class DynamicViewService extends BaseService {
    initialisationService: InitialisationService;
    private componentFactoryResolver;
    private injector;
    private compiler;
    dynamicComponentRegistry: RegistryItem[];
    constructor(initialisationService: InitialisationService, componentFactoryResolver: ComponentFactoryResolver, injector: Injector, compiler: Compiler);
    GetDynamicComponent(internalName: string): Promise<any>;
    private GetModulePathFromRegistryItem;
    private getRegistryItemForView;
    private getDynamicContentErrorComponent;
    simulateResolver(view: View): Promise<boolean>;
}
