import { HttpEvent, HttpInterceptor, HttpHandler, HttpRequest } from '@angular/common/http';
import { Observable, Subject } from 'rxjs';
import { LoginService } from './login.service';
import { DataContext } from 'qmuzik-angular-model-core';
import { AppManagementService } from './app-management.service';
import { DataContextService } from './data-context.service';
import { NotificationService } from './notification.service';
export declare class Interceptor implements HttpInterceptor {
    private loginService;
    private appManagementService;
    private dataContextService;
    private notificationService;
    constructor(loginService: LoginService, appManagementService: AppManagementService, dataContextService: DataContextService, notificationService: NotificationService);
    private refreshSubject;
    intercept(req: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>>;
    handleTokenExpired(dataContext: DataContext, i: number): Subject<any>;
    updateHeader(req: any, i: number): any;
}
